// This C++ header file was generated by the TTCN-3 compiler
// of the TTCN-3 Test Executor version 9.0.0
// The generation of user and time information were disabled by the -D flag.

// Copyright (c) 2000-2023 Ericsson Telecom AB

// Do not edit this file unless you know what you are doing.

#ifndef JSON__Types_HH
#define JSON__Types_HH

#ifdef TITAN_RUNTIME_2
#error Generated code does not match with used runtime.\
 Code was generated without -R option but -DTITAN_RUNTIME_2 was used.
#endif

/* Header file includes */

#include <TTCN3.hh>

#if TTCN3_VERSION != 90000
#error Version mismatch detected.\
 Please check the version of the TTCN-3 compiler and the base library.\
 Run make clean and rebuild the project if the version of the compiler changed recently.
#endif

#ifndef LINUX
#error This file should be compiled on LINUX
#endif

#undef JSON__Types_HH
#endif

namespace JSON__Types {

/* Forward declarations of classes */

class JSON__PDU;
class JSON__PDU_template;
class JSON__Object;
class JSON__Object_template;
class JSON__Value;
class JSON__Value_template;
class JSON__Array;
class JSON__Array_template;
class JSON__True__TEXT;
class JSON__True__TEXT_template;
class JSON__False__TEXT;
class JSON__False__TEXT_template;
class JSON__Null__TEXT;
class JSON__Null__TEXT_template;
class JSON__AVP;
class JSON__AVP_template;
class JSON__EscapeAction;
class JSON__EscapeAction_template;

} /* end of namespace */

#ifndef JSON__Types_HH
#define JSON__Types_HH

namespace JSON__Types {

/* Type definitions */

typedef UNIVERSAL_CHARSTRING JSON__String;
typedef UNIVERSAL_CHARSTRING_template JSON__String_template;
typedef INTEGER JSON__Number;
typedef INTEGER_template JSON__Number_template;

/* Class definitions */

class JSON__PDU : public Base_Type {
public:
enum union_selection_type { UNBOUND_VALUE = 0, ALT_json__object = 1, ALT_json__array = 2 };
private:
union_selection_type union_selection;
union {
JSON__Object *field_json__object;
JSON__Array *field_json__array;
};
void copy_value(const JSON__PDU& other_value);

public:
JSON__PDU();
JSON__PDU(const JSON__PDU& other_value);
~JSON__PDU();
JSON__PDU& operator=(const JSON__PDU& other_value);
boolean operator==(const JSON__PDU& other_value) const;
inline boolean operator!=(const JSON__PDU& other_value) const { return !(*this == other_value); }
JSON__Object& json__object();
const JSON__Object& json__object() const;
JSON__Array& json__array();
const JSON__Array& json__array() const;
inline union_selection_type get_selection() const { return union_selection; }
boolean ischosen(union_selection_type checked_selection) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
  void set_implicit_omit();
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__PDU_template : public Base_Template {
union {
struct {
JSON__PDU::union_selection_type union_selection;
union {
JSON__Object_template *field_json__object;
JSON__Array_template *field_json__array;
};
} single_value;
struct {
unsigned int n_values;
JSON__PDU_template *list_value;
} value_list;
struct {
JSON__PDU_template* precondition;
JSON__PDU_template* implied_template;
} implication_;
dynmatch_struct<JSON__PDU>* dyn_match;
};
void copy_value(const JSON__PDU& other_value);

void copy_template(const JSON__PDU_template& other_value);

public:
JSON__PDU_template();
JSON__PDU_template(template_sel other_value);
JSON__PDU_template(const JSON__PDU& other_value);
JSON__PDU_template(const OPTIONAL<JSON__PDU>& other_value);
JSON__PDU_template(JSON__PDU_template* p_precondition, JSON__PDU_template* p_implied_template);
JSON__PDU_template(Dynamic_Match_Interface<JSON__PDU>* p_dyn_match);
JSON__PDU_template(const JSON__PDU_template& other_value);
~JSON__PDU_template();
void clean_up();
JSON__PDU_template& operator=(template_sel other_value);
JSON__PDU_template& operator=(const JSON__PDU& other_value);
JSON__PDU_template& operator=(const OPTIONAL<JSON__PDU>& other_value);
JSON__PDU_template& operator=(const JSON__PDU_template& other_value);
boolean match(const JSON__PDU& other_value, boolean legacy = FALSE) const;
boolean is_value() const;JSON__PDU valueof() const;
JSON__PDU_template& list_item(unsigned int list_index) const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__Object_template& json__object();
const JSON__Object_template& json__object() const;
JSON__Array_template& json__array();
const JSON__Array_template& json__array() const;
boolean ischosen(JSON__PDU::union_selection_type checked_selection) const;
void log() const;
void log_match(const JSON__PDU& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class JSON__Object : public Base_Type {
struct recordof_setof_struct {
int ref_count;
int n_elements;
JSON__AVP **value_elements;
} *val_ptr;

static const JSON__AVP UNBOUND_ELEM;
private:
friend boolean operator==(null_type null_value, const JSON__Object& other_value);
static boolean compare_function(const Base_Type *left_ptr, int left_index, const Base_Type *right_ptr, int right_index);

public:
  typedef JSON__AVP of_type;
JSON__Object();
JSON__Object(null_type other_value);
JSON__Object(const JSON__Object& other_value);
~JSON__Object();

void clean_up();
JSON__Object& operator=(null_type other_value);
JSON__Object& operator=(const JSON__Object& other_value);

boolean operator==(null_type other_value) const;
boolean operator==(const JSON__Object& other_value) const;
inline boolean operator!=(null_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const JSON__Object& other_value) const { return !(*this == other_value); }

JSON__AVP& operator[](int index_value);
JSON__AVP& operator[](const INTEGER& index_value);
const JSON__AVP& operator[](int index_value) const;
const JSON__AVP& operator[](const INTEGER& index_value) const;

JSON__Object operator<<=(int rotate_count) const;
JSON__Object operator<<=(const INTEGER& rotate_count) const;
JSON__Object operator>>=(int rotate_count) const;
JSON__Object operator>>=(const INTEGER& rotate_count) const;

JSON__Object operator+(const JSON__Object& other_value) const;

JSON__Object substr(int index, int returncount) const;

JSON__Object replace(int index, int len, const JSON__Object& repl) const;

JSON__Object replace(int index, int len, const JSON__Object_template& repl) const;

void set_size(int new_size);
inline boolean is_bound() const {return val_ptr != NULL; }
inline boolean is_present() const { return is_bound(); }
boolean is_value() const;
int size_of() const;
int n_elem() const { return size_of(); }
int lengthof() const;
void log() const;
  void set_implicit_omit();
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__Object_template : public Restricted_Length_Template {
union {
struct {
int n_elements;
JSON__AVP_template **value_elements;
} single_value;
struct {
unsigned int n_values;
JSON__Object_template *list_value;
} value_list;
struct {
JSON__Object_template* precondition;
JSON__Object_template* implied_template;
} implication_;
dynmatch_struct<JSON__Object>* dyn_match;
struct {
unsigned int n_items;
JSON__AVP_template *set_items;
} value_set;
};
void copy_value(const JSON__Object& other_value);
void copy_template(const JSON__Object_template& other_value);
static boolean match_function_specific(const Base_Type *value_ptr, int value_index, const Restricted_Length_Template *template_ptr, int template_index, boolean legacy);
static boolean match_function_set(const Base_Type *value_ptr, int value_index, const Restricted_Length_Template *template_ptr, int template_index, boolean legacy);
static void log_function(const Base_Type *value_ptr, const Restricted_Length_Template *template_ptr, int index_value, int index_template, boolean legacy);

public:
JSON__Object_template();
JSON__Object_template(template_sel other_value);
JSON__Object_template(null_type other_value);
JSON__Object_template(const JSON__Object& other_value);
JSON__Object_template(const OPTIONAL<JSON__Object>& other_value);
JSON__Object_template(JSON__Object_template* p_precondition, JSON__Object_template* p_implied_template);
JSON__Object_template(Dynamic_Match_Interface<JSON__Object>* p_dyn_match);
JSON__Object_template(const JSON__Object_template& other_value);
~JSON__Object_template();

void clean_up();
JSON__Object_template& operator=(template_sel other_value);
JSON__Object_template& operator=(null_type other_value);
JSON__Object_template& operator=(const JSON__Object& other_value);
JSON__Object_template& operator=(const OPTIONAL<JSON__Object>& other_value);
JSON__Object_template& operator=(const JSON__Object_template& other_value);

JSON__AVP_template& operator[](int index_value);
JSON__AVP_template& operator[](const INTEGER& index_value);
const JSON__AVP_template& operator[](int index_value) const;
const JSON__AVP_template& operator[](const INTEGER& index_value) const;

void set_size(int new_size);
int n_elem() const;
int size_of(boolean is_size) const;
inline int size_of() const { return size_of(TRUE); }
inline int lengthof() const { return size_of(FALSE); }
boolean match(const JSON__Object& other_value, boolean legacy = FALSE) const;
inline boolean is_bound() const 
  {return template_selection != UNINITIALIZED_TEMPLATE; }
boolean is_value() const;
JSON__Object valueof() const;
JSON__Object substr(int index, int returncount) const;

JSON__Object replace(int index, int len, const JSON__Object_template& repl) const;

JSON__Object replace(int index, int len, const JSON__Object& repl) const;

void set_type(template_sel template_type, unsigned int list_length);
JSON__Object_template& list_item(unsigned int list_index);
JSON__AVP_template& set_item(unsigned int set_index);
void log() const;
void log_match(const JSON__Object& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean get_istemplate_kind(const char* type) const;
};

class JSON__Value : public Base_Type {
public:
enum union_selection_type { UNBOUND_VALUE = 0, ALT_json__object = 1, ALT_json__array = 2, ALT_json__string = 3, ALT_json__number = 4, ALT_json__true = 5, ALT_json__false = 6, ALT_json__null = 7 };
private:
union_selection_type union_selection;
union {
JSON__Object *field_json__object;
JSON__Array *field_json__array;
UNIVERSAL_CHARSTRING *field_json__string;
INTEGER *field_json__number;
JSON__True__TEXT *field_json__true;
JSON__False__TEXT *field_json__false;
JSON__Null__TEXT *field_json__null;
};
void copy_value(const JSON__Value& other_value);

public:
JSON__Value();
JSON__Value(const JSON__Value& other_value);
~JSON__Value();
JSON__Value& operator=(const JSON__Value& other_value);
boolean operator==(const JSON__Value& other_value) const;
inline boolean operator!=(const JSON__Value& other_value) const { return !(*this == other_value); }
JSON__Object& json__object();
const JSON__Object& json__object() const;
JSON__Array& json__array();
const JSON__Array& json__array() const;
UNIVERSAL_CHARSTRING& json__string();
const UNIVERSAL_CHARSTRING& json__string() const;
INTEGER& json__number();
const INTEGER& json__number() const;
JSON__True__TEXT& json__true();
const JSON__True__TEXT& json__true() const;
JSON__False__TEXT& json__false();
const JSON__False__TEXT& json__false() const;
JSON__Null__TEXT& json__null();
const JSON__Null__TEXT& json__null() const;
inline union_selection_type get_selection() const { return union_selection; }
boolean ischosen(union_selection_type checked_selection) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
  void set_implicit_omit();
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__Value_template : public Base_Template {
union {
struct {
JSON__Value::union_selection_type union_selection;
union {
JSON__Object_template *field_json__object;
JSON__Array_template *field_json__array;
UNIVERSAL_CHARSTRING_template *field_json__string;
INTEGER_template *field_json__number;
JSON__True__TEXT_template *field_json__true;
JSON__False__TEXT_template *field_json__false;
JSON__Null__TEXT_template *field_json__null;
};
} single_value;
struct {
unsigned int n_values;
JSON__Value_template *list_value;
} value_list;
struct {
JSON__Value_template* precondition;
JSON__Value_template* implied_template;
} implication_;
dynmatch_struct<JSON__Value>* dyn_match;
};
void copy_value(const JSON__Value& other_value);

void copy_template(const JSON__Value_template& other_value);

public:
JSON__Value_template();
JSON__Value_template(template_sel other_value);
JSON__Value_template(const JSON__Value& other_value);
JSON__Value_template(const OPTIONAL<JSON__Value>& other_value);
JSON__Value_template(JSON__Value_template* p_precondition, JSON__Value_template* p_implied_template);
JSON__Value_template(Dynamic_Match_Interface<JSON__Value>* p_dyn_match);
JSON__Value_template(const JSON__Value_template& other_value);
~JSON__Value_template();
void clean_up();
JSON__Value_template& operator=(template_sel other_value);
JSON__Value_template& operator=(const JSON__Value& other_value);
JSON__Value_template& operator=(const OPTIONAL<JSON__Value>& other_value);
JSON__Value_template& operator=(const JSON__Value_template& other_value);
boolean match(const JSON__Value& other_value, boolean legacy = FALSE) const;
boolean is_value() const;JSON__Value valueof() const;
JSON__Value_template& list_item(unsigned int list_index) const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__Object_template& json__object();
const JSON__Object_template& json__object() const;
JSON__Array_template& json__array();
const JSON__Array_template& json__array() const;
UNIVERSAL_CHARSTRING_template& json__string();
const UNIVERSAL_CHARSTRING_template& json__string() const;
INTEGER_template& json__number();
const INTEGER_template& json__number() const;
JSON__True__TEXT_template& json__true();
const JSON__True__TEXT_template& json__true() const;
JSON__False__TEXT_template& json__false();
const JSON__False__TEXT_template& json__false() const;
JSON__Null__TEXT_template& json__null();
const JSON__Null__TEXT_template& json__null() const;
boolean ischosen(JSON__Value::union_selection_type checked_selection) const;
void log() const;
void log_match(const JSON__Value& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class JSON__Array : public Base_Type {
struct recordof_setof_struct {
int ref_count;
int n_elements;
JSON__Value **value_elements;
} *val_ptr;

static const JSON__Value UNBOUND_ELEM;
private:
friend boolean operator==(null_type null_value, const JSON__Array& other_value);
static boolean compare_function(const Base_Type *left_ptr, int left_index, const Base_Type *right_ptr, int right_index);

public:
  typedef JSON__Value of_type;
JSON__Array();
JSON__Array(null_type other_value);
JSON__Array(const JSON__Array& other_value);
~JSON__Array();

void clean_up();
JSON__Array& operator=(null_type other_value);
JSON__Array& operator=(const JSON__Array& other_value);

boolean operator==(null_type other_value) const;
boolean operator==(const JSON__Array& other_value) const;
inline boolean operator!=(null_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const JSON__Array& other_value) const { return !(*this == other_value); }

JSON__Value& operator[](int index_value);
JSON__Value& operator[](const INTEGER& index_value);
const JSON__Value& operator[](int index_value) const;
const JSON__Value& operator[](const INTEGER& index_value) const;

JSON__Array operator<<=(int rotate_count) const;
JSON__Array operator<<=(const INTEGER& rotate_count) const;
JSON__Array operator>>=(int rotate_count) const;
JSON__Array operator>>=(const INTEGER& rotate_count) const;

JSON__Array operator+(const JSON__Array& other_value) const;

JSON__Array substr(int index, int returncount) const;

JSON__Array replace(int index, int len, const JSON__Array& repl) const;

JSON__Array replace(int index, int len, const JSON__Array_template& repl) const;

void set_size(int new_size);
inline boolean is_bound() const {return val_ptr != NULL; }
inline boolean is_present() const { return is_bound(); }
boolean is_value() const;
int size_of() const;
int n_elem() const { return size_of(); }
int lengthof() const;
void log() const;
  void set_implicit_omit();
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__Array_template : public Restricted_Length_Template {
union {
struct {
int n_elements;
JSON__Value_template **value_elements;
} single_value;
struct {
unsigned int n_values;
JSON__Array_template *list_value;
} value_list;
struct {
JSON__Array_template* precondition;
JSON__Array_template* implied_template;
} implication_;
dynmatch_struct<JSON__Array>* dyn_match;
struct {
unsigned int n_items;
JSON__Value_template *set_items;
} value_set;
};
void copy_value(const JSON__Array& other_value);
void copy_template(const JSON__Array_template& other_value);
static boolean match_function_specific(const Base_Type *value_ptr, int value_index, const Restricted_Length_Template *template_ptr, int template_index, boolean legacy);
static boolean match_function_set(const Base_Type *value_ptr, int value_index, const Restricted_Length_Template *template_ptr, int template_index, boolean legacy);
static void log_function(const Base_Type *value_ptr, const Restricted_Length_Template *template_ptr, int index_value, int index_template, boolean legacy);

public:
JSON__Array_template();
JSON__Array_template(template_sel other_value);
JSON__Array_template(null_type other_value);
JSON__Array_template(const JSON__Array& other_value);
JSON__Array_template(const OPTIONAL<JSON__Array>& other_value);
JSON__Array_template(JSON__Array_template* p_precondition, JSON__Array_template* p_implied_template);
JSON__Array_template(Dynamic_Match_Interface<JSON__Array>* p_dyn_match);
JSON__Array_template(const JSON__Array_template& other_value);
~JSON__Array_template();

void clean_up();
JSON__Array_template& operator=(template_sel other_value);
JSON__Array_template& operator=(null_type other_value);
JSON__Array_template& operator=(const JSON__Array& other_value);
JSON__Array_template& operator=(const OPTIONAL<JSON__Array>& other_value);
JSON__Array_template& operator=(const JSON__Array_template& other_value);

JSON__Value_template& operator[](int index_value);
JSON__Value_template& operator[](const INTEGER& index_value);
const JSON__Value_template& operator[](int index_value) const;
const JSON__Value_template& operator[](const INTEGER& index_value) const;

void set_size(int new_size);
int n_elem() const;
int size_of(boolean is_size) const;
inline int size_of() const { return size_of(TRUE); }
inline int lengthof() const { return size_of(FALSE); }
boolean match(const JSON__Array& other_value, boolean legacy = FALSE) const;
inline boolean is_bound() const 
  {return template_selection != UNINITIALIZED_TEMPLATE; }
boolean is_value() const;
JSON__Array valueof() const;
JSON__Array substr(int index, int returncount) const;

JSON__Array replace(int index, int len, const JSON__Array_template& repl) const;

JSON__Array replace(int index, int len, const JSON__Array& repl) const;

void set_type(template_sel template_type, unsigned int list_length);
JSON__Array_template& list_item(unsigned int list_index);
JSON__Value_template& set_item(unsigned int set_index);
void log() const;
void log_match(const JSON__Array& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean get_istemplate_kind(const char* type) const;
};

class JSON__True__TEXT : public Base_Type {
boolean bound_flag;
public:
JSON__True__TEXT();
JSON__True__TEXT(null_type other_value);
JSON__True__TEXT(const JSON__True__TEXT& other_value);
JSON__True__TEXT& operator=(null_type other_value);
JSON__True__TEXT& operator=(const JSON__True__TEXT& other_value);
boolean operator==(null_type other_value) const;
boolean operator==(const JSON__True__TEXT& other_value) const;
inline boolean operator!=(null_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const JSON__True__TEXT& other_value) const { return !(*this == other_value); }
inline boolean is_bound() const { return bound_flag; }
inline boolean is_present() const { return is_bound(); }
inline boolean is_value() const { return bound_flag; }
inline void clean_up() { bound_flag = FALSE; }
inline void must_bound(const char *err_msg) const { if (!bound_flag) TTCN_error("%s", err_msg); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__True__TEXT_template : public Base_Template {
union {
struct {
unsigned int n_values;
JSON__True__TEXT_template *list_value;
} value_list;
struct {
JSON__True__TEXT_template* precondition;
JSON__True__TEXT_template* implied_template;
} implication_;
dynmatch_struct<JSON__True__TEXT>* dyn_match;
};
void copy_template(const JSON__True__TEXT_template& other_value);

public:
JSON__True__TEXT_template();
JSON__True__TEXT_template(template_sel other_value);
JSON__True__TEXT_template(null_type other_value);
JSON__True__TEXT_template(const JSON__True__TEXT& other_value);
JSON__True__TEXT_template(const OPTIONAL<JSON__True__TEXT>& other_value);
JSON__True__TEXT_template(JSON__True__TEXT_template* p_precondition, JSON__True__TEXT_template* p_implied_template);
JSON__True__TEXT_template(Dynamic_Match_Interface<JSON__True__TEXT>* p_dyn_match);
JSON__True__TEXT_template(const JSON__True__TEXT_template& other_value);
~JSON__True__TEXT_template();
void clean_up();
JSON__True__TEXT_template& operator=(template_sel other_value);
JSON__True__TEXT_template& operator=(null_type other_value);
JSON__True__TEXT_template& operator=(const JSON__True__TEXT& other_value);
JSON__True__TEXT_template& operator=(const OPTIONAL<JSON__True__TEXT>& other_value);
JSON__True__TEXT_template& operator=(const JSON__True__TEXT_template& other_value);
boolean match(null_type other_value, boolean legacy = FALSE) const;
boolean match(const JSON__True__TEXT& other_value, boolean legacy = FALSE) const;
JSON__True__TEXT valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__True__TEXT_template& list_item(unsigned int list_index) const;
void log() const;
void log_match(const JSON__True__TEXT& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class JSON__False__TEXT : public Base_Type {
boolean bound_flag;
public:
JSON__False__TEXT();
JSON__False__TEXT(null_type other_value);
JSON__False__TEXT(const JSON__False__TEXT& other_value);
JSON__False__TEXT& operator=(null_type other_value);
JSON__False__TEXT& operator=(const JSON__False__TEXT& other_value);
boolean operator==(null_type other_value) const;
boolean operator==(const JSON__False__TEXT& other_value) const;
inline boolean operator!=(null_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const JSON__False__TEXT& other_value) const { return !(*this == other_value); }
inline boolean is_bound() const { return bound_flag; }
inline boolean is_present() const { return is_bound(); }
inline boolean is_value() const { return bound_flag; }
inline void clean_up() { bound_flag = FALSE; }
inline void must_bound(const char *err_msg) const { if (!bound_flag) TTCN_error("%s", err_msg); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__False__TEXT_template : public Base_Template {
union {
struct {
unsigned int n_values;
JSON__False__TEXT_template *list_value;
} value_list;
struct {
JSON__False__TEXT_template* precondition;
JSON__False__TEXT_template* implied_template;
} implication_;
dynmatch_struct<JSON__False__TEXT>* dyn_match;
};
void copy_template(const JSON__False__TEXT_template& other_value);

public:
JSON__False__TEXT_template();
JSON__False__TEXT_template(template_sel other_value);
JSON__False__TEXT_template(null_type other_value);
JSON__False__TEXT_template(const JSON__False__TEXT& other_value);
JSON__False__TEXT_template(const OPTIONAL<JSON__False__TEXT>& other_value);
JSON__False__TEXT_template(JSON__False__TEXT_template* p_precondition, JSON__False__TEXT_template* p_implied_template);
JSON__False__TEXT_template(Dynamic_Match_Interface<JSON__False__TEXT>* p_dyn_match);
JSON__False__TEXT_template(const JSON__False__TEXT_template& other_value);
~JSON__False__TEXT_template();
void clean_up();
JSON__False__TEXT_template& operator=(template_sel other_value);
JSON__False__TEXT_template& operator=(null_type other_value);
JSON__False__TEXT_template& operator=(const JSON__False__TEXT& other_value);
JSON__False__TEXT_template& operator=(const OPTIONAL<JSON__False__TEXT>& other_value);
JSON__False__TEXT_template& operator=(const JSON__False__TEXT_template& other_value);
boolean match(null_type other_value, boolean legacy = FALSE) const;
boolean match(const JSON__False__TEXT& other_value, boolean legacy = FALSE) const;
JSON__False__TEXT valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__False__TEXT_template& list_item(unsigned int list_index) const;
void log() const;
void log_match(const JSON__False__TEXT& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class JSON__Null__TEXT : public Base_Type {
boolean bound_flag;
public:
JSON__Null__TEXT();
JSON__Null__TEXT(null_type other_value);
JSON__Null__TEXT(const JSON__Null__TEXT& other_value);
JSON__Null__TEXT& operator=(null_type other_value);
JSON__Null__TEXT& operator=(const JSON__Null__TEXT& other_value);
boolean operator==(null_type other_value) const;
boolean operator==(const JSON__Null__TEXT& other_value) const;
inline boolean operator!=(null_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const JSON__Null__TEXT& other_value) const { return !(*this == other_value); }
inline boolean is_bound() const { return bound_flag; }
inline boolean is_present() const { return is_bound(); }
inline boolean is_value() const { return bound_flag; }
inline void clean_up() { bound_flag = FALSE; }
inline void must_bound(const char *err_msg) const { if (!bound_flag) TTCN_error("%s", err_msg); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__Null__TEXT_template : public Base_Template {
union {
struct {
unsigned int n_values;
JSON__Null__TEXT_template *list_value;
} value_list;
struct {
JSON__Null__TEXT_template* precondition;
JSON__Null__TEXT_template* implied_template;
} implication_;
dynmatch_struct<JSON__Null__TEXT>* dyn_match;
};
void copy_template(const JSON__Null__TEXT_template& other_value);

public:
JSON__Null__TEXT_template();
JSON__Null__TEXT_template(template_sel other_value);
JSON__Null__TEXT_template(null_type other_value);
JSON__Null__TEXT_template(const JSON__Null__TEXT& other_value);
JSON__Null__TEXT_template(const OPTIONAL<JSON__Null__TEXT>& other_value);
JSON__Null__TEXT_template(JSON__Null__TEXT_template* p_precondition, JSON__Null__TEXT_template* p_implied_template);
JSON__Null__TEXT_template(Dynamic_Match_Interface<JSON__Null__TEXT>* p_dyn_match);
JSON__Null__TEXT_template(const JSON__Null__TEXT_template& other_value);
~JSON__Null__TEXT_template();
void clean_up();
JSON__Null__TEXT_template& operator=(template_sel other_value);
JSON__Null__TEXT_template& operator=(null_type other_value);
JSON__Null__TEXT_template& operator=(const JSON__Null__TEXT& other_value);
JSON__Null__TEXT_template& operator=(const OPTIONAL<JSON__Null__TEXT>& other_value);
JSON__Null__TEXT_template& operator=(const JSON__Null__TEXT_template& other_value);
boolean match(null_type other_value, boolean legacy = FALSE) const;
boolean match(const JSON__Null__TEXT& other_value, boolean legacy = FALSE) const;
JSON__Null__TEXT valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__Null__TEXT_template& list_item(unsigned int list_index) const;
void log() const;
void log_match(const JSON__Null__TEXT& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class JSON__AVP : public Base_Type {
  UNIVERSAL_CHARSTRING field_json__name;
  JSON__Value field_json__value;
public:
  JSON__AVP();
  JSON__AVP(const UNIVERSAL_CHARSTRING& par_json__name,
    const JSON__Value& par_json__value);
  JSON__AVP(const JSON__AVP& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  JSON__AVP& operator=(const JSON__AVP& other_value);
  boolean operator==(const JSON__AVP& other_value) const;
  inline boolean operator!=(const JSON__AVP& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline UNIVERSAL_CHARSTRING& json__name()
    {return field_json__name;}
  inline const UNIVERSAL_CHARSTRING& json__name() const
    {return field_json__name;}
  inline JSON__Value& json__value()
    {return field_json__value;}
  inline const JSON__Value& json__value() const
    {return field_json__value;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__AVP_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
JSON__AVP_template *list_value;
} value_list;
struct {
JSON__AVP_template* precondition;
JSON__AVP_template* implied_template;
} implication_;
dynmatch_struct<JSON__AVP>* dyn_match;
};

void set_specific();
void copy_value(const JSON__AVP& other_value);
void copy_template(const JSON__AVP_template& other_value);

public:
JSON__AVP_template();
JSON__AVP_template(template_sel other_value);
JSON__AVP_template(const JSON__AVP& other_value);
JSON__AVP_template(const OPTIONAL<JSON__AVP>& other_value);
JSON__AVP_template(JSON__AVP_template* p_precondition, JSON__AVP_template* p_implied_template);
JSON__AVP_template(Dynamic_Match_Interface<JSON__AVP>* p_dyn_match);
JSON__AVP_template(const JSON__AVP_template& other_value);
~JSON__AVP_template();
JSON__AVP_template& operator=(template_sel other_value);
JSON__AVP_template& operator=(const JSON__AVP& other_value);
JSON__AVP_template& operator=(const OPTIONAL<JSON__AVP>& other_value);
JSON__AVP_template& operator=(const JSON__AVP_template& other_value);
boolean match(const JSON__AVP& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
JSON__AVP valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__AVP_template& list_item(unsigned int list_index) const;
UNIVERSAL_CHARSTRING_template& json__name();
const UNIVERSAL_CHARSTRING_template& json__name() const;
JSON__Value_template& json__value();
const JSON__Value_template& json__value() const;
int size_of() const;
void log() const;
void log_match(const JSON__AVP& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class JSON__EscapeAction : public Base_Type { // enum
friend class JSON__EscapeAction_template;
public:
enum enum_type { escape = 0, unescape = 1, UNKNOWN_VALUE = 2, UNBOUND_VALUE = 3 };
private:
enum_type enum_value;

public:
JSON__EscapeAction();
JSON__EscapeAction(int other_value);
JSON__EscapeAction(enum_type other_value);
JSON__EscapeAction(const JSON__EscapeAction& other_value);

JSON__EscapeAction& operator=(int other_value);
JSON__EscapeAction& operator=(enum_type other_value);
JSON__EscapeAction& operator=(const JSON__EscapeAction& other_value);

boolean operator==(enum_type other_value) const;
boolean operator==(const JSON__EscapeAction& other_value) const;
inline boolean operator!=(enum_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const JSON__EscapeAction& other_value) const { return !(*this == other_value); }
boolean operator<(enum_type other_value) const;
boolean operator<(const JSON__EscapeAction& other_value) const;
boolean operator>(enum_type other_value) const;
boolean operator>(const JSON__EscapeAction& other_value) const;
inline boolean operator<=(enum_type other_value) const { return !(*this > other_value); }
inline boolean operator<=(const JSON__EscapeAction& other_value) const { return !(*this > other_value); }
inline boolean operator>=(enum_type other_value) const { return !(*this < other_value); }
inline boolean operator>=(const JSON__EscapeAction& other_value) const { return !(*this < other_value); }

static const char *enum_to_str(enum_type enum_par);
static enum_type str_to_enum(const char *str_par);
static boolean is_valid_enum(int int_par);

static int enum2int(enum_type enum_par);
static int enum2int(const JSON__EscapeAction& enum_par);
int as_int() const { return enum2int(enum_value); }
void from_int(int p_val) { *this = p_val; }
void int2enum(int int_val);
operator enum_type() const;
inline boolean is_bound() const { return enum_value != UNBOUND_VALUE; }
inline boolean is_value() const { return enum_value != UNBOUND_VALUE; }
inline void clean_up(){ enum_value = UNBOUND_VALUE; }
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
int TEXT_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int TEXT_decode(const TTCN_Typedescriptor_t&,TTCN_Buffer&, Limit_Token_List&, boolean no_err=FALSE,boolean first_call=TRUE);
};

class JSON__EscapeAction_template : public Base_Template {
union {
JSON__EscapeAction::enum_type single_value;
struct {
unsigned int n_values;
JSON__EscapeAction_template *list_value;
} value_list;
struct {
JSON__EscapeAction_template* precondition;
JSON__EscapeAction_template* implied_template;
} implication_;
dynmatch_struct<JSON__EscapeAction>* dyn_match;
};

void copy_template(const JSON__EscapeAction_template& other_value);

public:
JSON__EscapeAction_template();
JSON__EscapeAction_template(template_sel other_value);
JSON__EscapeAction_template(int other_value);
JSON__EscapeAction_template(JSON__EscapeAction::enum_type other_value);
JSON__EscapeAction_template(const JSON__EscapeAction& other_value);
JSON__EscapeAction_template(const OPTIONAL<JSON__EscapeAction>& other_value);
JSON__EscapeAction_template(JSON__EscapeAction_template* p_precondition, JSON__EscapeAction_template* p_implied_template);
JSON__EscapeAction_template(Dynamic_Match_Interface<JSON__EscapeAction>* p_dyn_match);
JSON__EscapeAction_template(const JSON__EscapeAction_template& other_value);
~JSON__EscapeAction_template();

boolean is_bound() const;
boolean is_value() const;
void clean_up();
JSON__EscapeAction_template& operator=(template_sel other_value);
JSON__EscapeAction_template& operator=(int other_value);
JSON__EscapeAction_template& operator=(JSON__EscapeAction::enum_type other_value);
JSON__EscapeAction_template& operator=(const JSON__EscapeAction& other_value);
JSON__EscapeAction_template& operator=(const OPTIONAL<JSON__EscapeAction>& other_value);
JSON__EscapeAction_template& operator=(const JSON__EscapeAction_template& other_value);

boolean match(JSON__EscapeAction::enum_type other_value, boolean legacy = FALSE) const;
boolean match(const JSON__EscapeAction& other_value, boolean legacy = FALSE) const;
JSON__EscapeAction::enum_type valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
JSON__EscapeAction_template& list_item(unsigned int list_index);
void log() const;
void log_match(const JSON__EscapeAction& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};


/* Function prototypes */

extern OCTETSTRING enc__JSON(const JSON__PDU& pdu);
extern JSON__PDU dec__JSON(const OCTETSTRING& msg);
extern INTEGER dec__JSON__Sliding(OCTETSTRING& msg, JSON__PDU& pdu);
extern OCTETSTRING enc__JSON__escaped(const JSON__PDU& pdu);
extern JSON__PDU dec__JSON__escaped(const OCTETSTRING& msg);
extern INTEGER dec__JSON__Sliding__escaped(const OCTETSTRING& msg, JSON__PDU& pdu);
extern boolean operator==(null_type null_value, const JSON__Object& other_value);
inline boolean operator!=(null_type null_value, const JSON__Object& other_value) { return !(null_value == other_value); }
extern void JSON__String_encoder(const UNIVERSAL_CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__String_decoder(OCTETSTRING& input_stream, UNIVERSAL_CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__Value_json__object_encoder(const JSON__Object& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Value_json__object_decoder(OCTETSTRING& input_stream, JSON__Object& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern boolean operator==(null_type null_value, const JSON__Array& other_value);
inline boolean operator!=(null_type null_value, const JSON__Array& other_value) { return !(null_value == other_value); }
extern void JSON__Array_0_encoder(const JSON__Value& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Array_0_decoder(OCTETSTRING& input_stream, JSON__Value& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__Array_encoder(const JSON__Array& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Array_decoder(OCTETSTRING& input_stream, JSON__Array& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__Number_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Number_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern boolean operator==(null_type null_value, const JSON__True__TEXT& other_value);
inline boolean operator!=(null_type null_value, const JSON__True__TEXT& other_value) { return !(null_value == other_value); }
extern void JSON__True__TEXT_encoder(const JSON__True__TEXT& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__True__TEXT_decoder(OCTETSTRING& input_stream, JSON__True__TEXT& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern boolean operator==(null_type null_value, const JSON__False__TEXT& other_value);
inline boolean operator!=(null_type null_value, const JSON__False__TEXT& other_value) { return !(null_value == other_value); }
extern void JSON__False__TEXT_encoder(const JSON__False__TEXT& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__False__TEXT_decoder(OCTETSTRING& input_stream, JSON__False__TEXT& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern boolean operator==(null_type null_value, const JSON__Null__TEXT& other_value);
inline boolean operator!=(null_type null_value, const JSON__Null__TEXT& other_value) { return !(null_value == other_value); }
extern void JSON__Null__TEXT_encoder(const JSON__Null__TEXT& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Null__TEXT_decoder(OCTETSTRING& input_stream, JSON__Null__TEXT& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__Value_encoder(const JSON__Value& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Value_decoder(OCTETSTRING& input_stream, JSON__Value& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__AVP_encoder(const JSON__AVP& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__AVP_decoder(OCTETSTRING& input_stream, JSON__AVP& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__Object_encoder(const JSON__Object& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__Object_decoder(OCTETSTRING& input_stream, JSON__Object& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__PDU_encoder(const JSON__PDU& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__PDU_decoder(OCTETSTRING& input_stream, JSON__PDU& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void JSON__EscapeAction_encoder(const JSON__EscapeAction& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER JSON__EscapeAction_decoder(OCTETSTRING& input_stream, JSON__EscapeAction& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void f__JSON__handleEscapes(JSON__PDU& pl__json, const JSON__EscapeAction& pl__action);
extern void f__JSON__handleEscapes__object(JSON__Object& pl__object, const JSON__EscapeAction& pl__action);
extern void f__JSON__handleEscapes__array(JSON__Array& pl__array, const JSON__EscapeAction& pl__action);
extern void f__JSON__handleEscapes__string(UNIVERSAL_CHARSTRING& pl__string, const JSON__EscapeAction& pl__action);
extern void pre_init_module();

/* Global variable declarations */

extern const TTCN_TEXTdescriptor_t JSON__PDU_text_;
extern const TTCN_Typedescriptor_t JSON__PDU_descr_;
extern const TTCN_TEXTdescriptor_param_values JSON__Object_par_;
extern const TTCN_TEXTdescriptor_t JSON__Object_text_;
extern const TTCN_Typedescriptor_t JSON__Object_descr_;
extern const TTCN_TEXTdescriptor_t JSON__String_text_;
extern const XERdescriptor_t JSON__String_xer_;
extern const TTCN_Typedescriptor_t JSON__String_descr_;
extern UNIVERSAL_CHARSTRING JSON__String_default_coding;
extern const XERdescriptor_t JSON__AVP_json__name_xer_;
extern const TTCN_Typedescriptor_t JSON__AVP_json__name_descr_;
extern UNIVERSAL_CHARSTRING JSON__AVP_json__name_default_coding;
extern const TTCN_TEXTdescriptor_t JSON__Value_text_;
extern const TTCN_Typedescriptor_t JSON__Value_descr_;
extern UNIVERSAL_CHARSTRING JSON__Value_json__object_default_coding;
extern const TTCN_TEXTdescriptor_param_values JSON__Array_par_;
extern const TTCN_TEXTdescriptor_t JSON__Array_text_;
extern const TTCN_Typedescriptor_t JSON__Array_descr_;
extern UNIVERSAL_CHARSTRING JSON__Array_0_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Array_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Value_json__array_default_coding;
extern const XERdescriptor_t JSON__Value_json__string_xer_;
extern const TTCN_Typedescriptor_t JSON__Value_json__string_descr_;
extern UNIVERSAL_CHARSTRING JSON__Value_json__string_default_coding;
extern const TTCN_TEXTdescriptor_t JSON__Number_text_;
extern const XERdescriptor_t JSON__Number_xer_;
extern const TTCN_Typedescriptor_t JSON__Number_descr_;
extern UNIVERSAL_CHARSTRING JSON__Number_default_coding;
extern const XERdescriptor_t JSON__Value_json__number_xer_;
extern const TTCN_OERdescriptor_t JSON__Value_json__number_oer_;
extern const TTCN_Typedescriptor_t JSON__Value_json__number_descr_;
extern UNIVERSAL_CHARSTRING JSON__Value_json__number_default_coding;
extern const TTCN_TEXTdescriptor_t JSON__True__TEXT_text_;
extern const TTCN_Typedescriptor_t JSON__True__TEXT_descr_;
extern UNIVERSAL_CHARSTRING JSON__True__TEXT_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Value_json__true_default_coding;
extern const TTCN_TEXTdescriptor_t JSON__False__TEXT_text_;
extern const TTCN_Typedescriptor_t JSON__False__TEXT_descr_;
extern UNIVERSAL_CHARSTRING JSON__False__TEXT_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Value_json__false_default_coding;
extern const TTCN_TEXTdescriptor_t JSON__Null__TEXT_text_;
extern const TTCN_Typedescriptor_t JSON__Null__TEXT_descr_;
extern UNIVERSAL_CHARSTRING JSON__Null__TEXT_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Value_json__null_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Value_default_coding;
extern UNIVERSAL_CHARSTRING JSON__AVP_json__value_default_coding;
extern const TTCN_TEXTdescriptor_t JSON__AVP_text_;
extern const TTCN_Typedescriptor_t JSON__AVP_descr_;
extern UNIVERSAL_CHARSTRING JSON__AVP_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Object_0_default_coding;
extern UNIVERSAL_CHARSTRING JSON__Object_default_coding;
extern UNIVERSAL_CHARSTRING JSON__PDU_json__object_default_coding;
extern UNIVERSAL_CHARSTRING JSON__PDU_json__array_default_coding;
extern UNIVERSAL_CHARSTRING JSON__PDU_default_coding;
extern const TTCN_TEXTdescriptor_enum JSON__EscapeAction_enum_[];
extern const TTCN_TEXTdescriptor_t JSON__EscapeAction_text_;
extern const TTCN_Typedescriptor_t JSON__EscapeAction_descr_;
extern UNIVERSAL_CHARSTRING JSON__EscapeAction_default_coding;
extern const CHARSTRING cs_4,
cs_3,
cs_2,
cs_10,
cs_5,
cs_6,
cs_8,
cs_9,
cs_7,
cs_0,
cs_1;
extern const unsigned char module_checksum[];
extern TTCN_Module module_object;
extern const RuntimeVersionChecker ver_checker;

} /* end of namespace */

#endif
