// This C++ header file was generated by the ASN.1 compiler
// of the TTCN-3 Test Executor version 9.0.0
// The generation of user and time information were disabled by the -D flag.

// Copyright (c) 2000-2023 Ericsson Telecom AB

// Do not edit this file unless you know what you are doing.

#ifndef RSPRO_HH
#define RSPRO_HH

#ifdef TITAN_RUNTIME_2
#error Generated code does not match with used runtime.\
 Code was generated without -R option but -DTITAN_RUNTIME_2 was used.
#endif

/* Header file includes */

#include <TTCN3.hh>

#if TTCN3_VERSION != 90000
#error Version mismatch detected.\
 Please check the version of the ASN.1 compiler and the base library.\
 Run make clean and rebuild the project if the version of the compiler changed recently.
#endif

#ifndef LINUX
#error This file should be compiled on LINUX
#endif

#undef RSPRO_HH
#endif

namespace RSPRO {

/* Forward declarations of classes */

class ComponentType;
class ComponentType_template;
class ComponentIdentity;
class ComponentIdentity_template;
class IpAddress;
class IpAddress_template;
class IpPort;
class IpPort_template;
class ResultCode;
class ResultCode_template;
class ErrorCode;
class ErrorCode_template;
class ErrorSeverity;
class ErrorSeverity_template;
class ClientSlot;
class ClientSlot_template;
class BankSlot;
class BankSlot_template;
class TpduFlags;
class TpduFlags_template;
class SlotPhysStatus;
class SlotPhysStatus_template;
class ConnectBankReq;
class ConnectBankReq_template;
class ConnectBankRes;
class ConnectBankRes_template;
class ConnectClientReq;
class ConnectClientReq_template;
class ConnectClientRes;
class ConnectClientRes_template;
class CreateMappingReq;
class CreateMappingReq_template;
class CreateMappingRes;
class CreateMappingRes_template;
class RemoveMappingReq;
class RemoveMappingReq_template;
class RemoveMappingRes;
class RemoveMappingRes_template;
class ConfigClientIdReq;
class ConfigClientIdReq_template;
class ConfigClientIdRes;
class ConfigClientIdRes_template;
class ConfigClientBankReq;
class ConfigClientBankReq_template;
class ConfigClientBankRes;
class ConfigClientBankRes_template;
class SetAtrReq;
class SetAtrReq_template;
class SetAtrRes;
class SetAtrRes_template;
class TpduModemToCard;
class TpduModemToCard_template;
class TpduCardToModem;
class TpduCardToModem_template;
class ClientSlotStatusInd;
class ClientSlotStatusInd_template;
class BankSlotStatusInd;
class BankSlotStatusInd_template;
class ErrorInd;
class ErrorInd_template;
class ResetStateReq;
class ResetStateReq_template;
class ResetStateRes;
class ResetStateRes_template;
class RsproPDUchoice;
class RsproPDUchoice_template;
class RsproPDU;
class RsproPDU_template;

} /* end of namespace */

#ifndef RSPRO_HH
#define RSPRO_HH

namespace RSPRO {

/* Type definitions */

typedef INTEGER OperationTag;
typedef INTEGER_template OperationTag_template;
typedef INTEGER BankId;
typedef INTEGER_template BankId_template;
typedef INTEGER ClientId;
typedef INTEGER_template ClientId_template;
typedef CHARSTRING ComponentName;
typedef CHARSTRING_template ComponentName_template;
typedef OCTETSTRING Ipv4Address;
typedef OCTETSTRING_template Ipv4Address_template;
typedef OCTETSTRING Ipv6Address;
typedef OCTETSTRING_template Ipv6Address_template;
typedef INTEGER PortNumber;
typedef INTEGER_template PortNumber_template;
typedef CHARSTRING ErrorString;
typedef CHARSTRING_template ErrorString_template;
typedef INTEGER SlotNumber;
typedef INTEGER_template SlotNumber_template;
typedef OCTETSTRING ATR;
typedef OCTETSTRING_template ATR_template;

/* Class definitions */

class ComponentType : public Base_Type { // enum
friend class ComponentType_template;
public:
enum enum_type { remsimClient = 0, remsimServer = 1, remsimBankd = 2, UNKNOWN_VALUE = 3, UNBOUND_VALUE = 4 };
private:
enum_type enum_value;

public:
ComponentType();
ComponentType(int other_value);
ComponentType(enum_type other_value);
ComponentType(const ComponentType& other_value);

ComponentType& operator=(int other_value);
ComponentType& operator=(enum_type other_value);
ComponentType& operator=(const ComponentType& other_value);

boolean operator==(enum_type other_value) const;
boolean operator==(const ComponentType& other_value) const;
inline boolean operator!=(enum_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const ComponentType& other_value) const { return !(*this == other_value); }
boolean operator<(enum_type other_value) const;
boolean operator<(const ComponentType& other_value) const;
boolean operator>(enum_type other_value) const;
boolean operator>(const ComponentType& other_value) const;
inline boolean operator<=(enum_type other_value) const { return !(*this > other_value); }
inline boolean operator<=(const ComponentType& other_value) const { return !(*this > other_value); }
inline boolean operator>=(enum_type other_value) const { return !(*this < other_value); }
inline boolean operator>=(const ComponentType& other_value) const { return !(*this < other_value); }

static const char *enum_to_str(enum_type enum_par);
static enum_type str_to_enum(const char *str_par);
static boolean is_valid_enum(int int_par);

static int enum2int(enum_type enum_par);
static int enum2int(const ComponentType& enum_par);
int as_int() const { return enum2int(enum_value); }
void from_int(int p_val) { *this = p_val; }
void int2enum(int int_val);
operator enum_type() const;
inline boolean is_bound() const { return enum_value != UNBOUND_VALUE; }
inline boolean is_value() const { return enum_value != UNBOUND_VALUE; }
inline void clean_up(){ enum_value = UNBOUND_VALUE; }
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ComponentType_template : public Base_Template {
union {
ComponentType::enum_type single_value;
struct {
unsigned int n_values;
ComponentType_template *list_value;
} value_list;
struct {
ComponentType_template* precondition;
ComponentType_template* implied_template;
} implication_;
dynmatch_struct<ComponentType>* dyn_match;
};

void copy_template(const ComponentType_template& other_value);

public:
ComponentType_template();
ComponentType_template(template_sel other_value);
ComponentType_template(int other_value);
ComponentType_template(ComponentType::enum_type other_value);
ComponentType_template(const ComponentType& other_value);
ComponentType_template(const OPTIONAL<ComponentType>& other_value);
ComponentType_template(ComponentType_template* p_precondition, ComponentType_template* p_implied_template);
ComponentType_template(Dynamic_Match_Interface<ComponentType>* p_dyn_match);
ComponentType_template(const ComponentType_template& other_value);
~ComponentType_template();

boolean is_bound() const;
boolean is_value() const;
void clean_up();
ComponentType_template& operator=(template_sel other_value);
ComponentType_template& operator=(int other_value);
ComponentType_template& operator=(ComponentType::enum_type other_value);
ComponentType_template& operator=(const ComponentType& other_value);
ComponentType_template& operator=(const OPTIONAL<ComponentType>& other_value);
ComponentType_template& operator=(const ComponentType_template& other_value);

boolean match(ComponentType::enum_type other_value, boolean legacy = FALSE) const;
boolean match(const ComponentType& other_value, boolean legacy = FALSE) const;
ComponentType::enum_type valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ComponentType_template& list_item(unsigned int list_index);
void log() const;
void log_match(const ComponentType& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class ComponentIdentity : public Base_Type {
  ComponentType field_type__;
  CHARSTRING field_name;
  CHARSTRING field_software;
  CHARSTRING field_swVersion;
  OPTIONAL< CHARSTRING > field_hwManufacturer;
  OPTIONAL< CHARSTRING > field_hwModel;
  OPTIONAL< CHARSTRING > field_hwSerialNr;
  OPTIONAL< CHARSTRING > field_hwVersion;
  OPTIONAL< CHARSTRING > field_fwVersion;
public:
  ComponentIdentity();
  ComponentIdentity(const ComponentType& par_type__,
    const CHARSTRING& par_name,
    const CHARSTRING& par_software,
    const CHARSTRING& par_swVersion,
    const OPTIONAL< CHARSTRING >& par_hwManufacturer,
    const OPTIONAL< CHARSTRING >& par_hwModel,
    const OPTIONAL< CHARSTRING >& par_hwSerialNr,
    const OPTIONAL< CHARSTRING >& par_hwVersion,
    const OPTIONAL< CHARSTRING >& par_fwVersion);
  ComponentIdentity(const ComponentIdentity& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ComponentIdentity& operator=(const ComponentIdentity& other_value);
  boolean operator==(const ComponentIdentity& other_value) const;
  inline boolean operator!=(const ComponentIdentity& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ComponentType& type__()
    {return field_type__;}
  inline const ComponentType& type__() const
    {return field_type__;}
  inline CHARSTRING& name()
    {return field_name;}
  inline const CHARSTRING& name() const
    {return field_name;}
  inline CHARSTRING& software()
    {return field_software;}
  inline const CHARSTRING& software() const
    {return field_software;}
  inline CHARSTRING& swVersion()
    {return field_swVersion;}
  inline const CHARSTRING& swVersion() const
    {return field_swVersion;}
  inline OPTIONAL< CHARSTRING >& hwManufacturer()
    {return field_hwManufacturer;}
  inline const OPTIONAL< CHARSTRING >& hwManufacturer() const
    {return field_hwManufacturer;}
  inline OPTIONAL< CHARSTRING >& hwModel()
    {return field_hwModel;}
  inline const OPTIONAL< CHARSTRING >& hwModel() const
    {return field_hwModel;}
  inline OPTIONAL< CHARSTRING >& hwSerialNr()
    {return field_hwSerialNr;}
  inline const OPTIONAL< CHARSTRING >& hwSerialNr() const
    {return field_hwSerialNr;}
  inline OPTIONAL< CHARSTRING >& hwVersion()
    {return field_hwVersion;}
  inline const OPTIONAL< CHARSTRING >& hwVersion() const
    {return field_hwVersion;}
  inline OPTIONAL< CHARSTRING >& fwVersion()
    {return field_fwVersion;}
  inline const OPTIONAL< CHARSTRING >& fwVersion() const
    {return field_fwVersion;}
  int size_of() const;
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ComponentIdentity_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ComponentIdentity_template *list_value;
} value_list;
struct {
ComponentIdentity_template* precondition;
ComponentIdentity_template* implied_template;
} implication_;
dynmatch_struct<ComponentIdentity>* dyn_match;
};

void set_specific();
void copy_value(const ComponentIdentity& other_value);
void copy_template(const ComponentIdentity_template& other_value);

public:
ComponentIdentity_template();
ComponentIdentity_template(template_sel other_value);
ComponentIdentity_template(const ComponentIdentity& other_value);
ComponentIdentity_template(const OPTIONAL<ComponentIdentity>& other_value);
ComponentIdentity_template(ComponentIdentity_template* p_precondition, ComponentIdentity_template* p_implied_template);
ComponentIdentity_template(Dynamic_Match_Interface<ComponentIdentity>* p_dyn_match);
ComponentIdentity_template(const ComponentIdentity_template& other_value);
~ComponentIdentity_template();
ComponentIdentity_template& operator=(template_sel other_value);
ComponentIdentity_template& operator=(const ComponentIdentity& other_value);
ComponentIdentity_template& operator=(const OPTIONAL<ComponentIdentity>& other_value);
ComponentIdentity_template& operator=(const ComponentIdentity_template& other_value);
boolean match(const ComponentIdentity& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ComponentIdentity valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ComponentIdentity_template& list_item(unsigned int list_index) const;
ComponentType_template& type__();
const ComponentType_template& type__() const;
CHARSTRING_template& name();
const CHARSTRING_template& name() const;
CHARSTRING_template& software();
const CHARSTRING_template& software() const;
CHARSTRING_template& swVersion();
const CHARSTRING_template& swVersion() const;
CHARSTRING_template& hwManufacturer();
const CHARSTRING_template& hwManufacturer() const;
CHARSTRING_template& hwModel();
const CHARSTRING_template& hwModel() const;
CHARSTRING_template& hwSerialNr();
const CHARSTRING_template& hwSerialNr() const;
CHARSTRING_template& hwVersion();
const CHARSTRING_template& hwVersion() const;
CHARSTRING_template& fwVersion();
const CHARSTRING_template& fwVersion() const;
int size_of() const;
void log() const;
void log_match(const ComponentIdentity& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class IpAddress : public Base_Type {
public:
enum union_selection_type { UNBOUND_VALUE = 0, ALT_ipv4 = 1, ALT_ipv6 = 2 };
private:
union_selection_type union_selection;
union {
OCTETSTRING *field_ipv4;
OCTETSTRING *field_ipv6;
};
void copy_value(const IpAddress& other_value);

public:
IpAddress();
IpAddress(const IpAddress& other_value);
~IpAddress();
IpAddress& operator=(const IpAddress& other_value);
boolean operator==(const IpAddress& other_value) const;
inline boolean operator!=(const IpAddress& other_value) const { return !(*this == other_value); }
OCTETSTRING& ipv4();
const OCTETSTRING& ipv4() const;
OCTETSTRING& ipv6();
const OCTETSTRING& ipv6() const;
inline union_selection_type get_selection() const { return union_selection; }
boolean ischosen(union_selection_type checked_selection) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
  void set_implicit_omit();
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
private:
boolean BER_decode_set_selection(const ASN_BER_TLV_t& p_tlv);
public:
boolean BER_decode_isMyMsg(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv);
};

class IpAddress_template : public Base_Template {
union {
struct {
IpAddress::union_selection_type union_selection;
union {
OCTETSTRING_template *field_ipv4;
OCTETSTRING_template *field_ipv6;
};
} single_value;
struct {
unsigned int n_values;
IpAddress_template *list_value;
} value_list;
struct {
IpAddress_template* precondition;
IpAddress_template* implied_template;
} implication_;
dynmatch_struct<IpAddress>* dyn_match;
};
void copy_value(const IpAddress& other_value);

void copy_template(const IpAddress_template& other_value);

public:
IpAddress_template();
IpAddress_template(template_sel other_value);
IpAddress_template(const IpAddress& other_value);
IpAddress_template(const OPTIONAL<IpAddress>& other_value);
IpAddress_template(IpAddress_template* p_precondition, IpAddress_template* p_implied_template);
IpAddress_template(Dynamic_Match_Interface<IpAddress>* p_dyn_match);
IpAddress_template(const IpAddress_template& other_value);
~IpAddress_template();
void clean_up();
IpAddress_template& operator=(template_sel other_value);
IpAddress_template& operator=(const IpAddress& other_value);
IpAddress_template& operator=(const OPTIONAL<IpAddress>& other_value);
IpAddress_template& operator=(const IpAddress_template& other_value);
boolean match(const IpAddress& other_value, boolean legacy = FALSE) const;
boolean is_value() const;IpAddress valueof() const;
IpAddress_template& list_item(unsigned int list_index) const;
void set_type(template_sel template_type, unsigned int list_length);
OCTETSTRING_template& ipv4();
const OCTETSTRING_template& ipv4() const;
OCTETSTRING_template& ipv6();
const OCTETSTRING_template& ipv6() const;
boolean ischosen(IpAddress::union_selection_type checked_selection) const;
void log() const;
void log_match(const IpAddress& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class IpPort : public Base_Type {
  IpAddress field_ip;
  INTEGER field_port__;
public:
  IpPort();
  IpPort(const IpAddress& par_ip,
    const INTEGER& par_port__);
  IpPort(const IpPort& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  IpPort& operator=(const IpPort& other_value);
  boolean operator==(const IpPort& other_value) const;
  inline boolean operator!=(const IpPort& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline IpAddress& ip()
    {return field_ip;}
  inline const IpAddress& ip() const
    {return field_ip;}
  inline INTEGER& port__()
    {return field_port__;}
  inline const INTEGER& port__() const
    {return field_port__;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class IpPort_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
IpPort_template *list_value;
} value_list;
struct {
IpPort_template* precondition;
IpPort_template* implied_template;
} implication_;
dynmatch_struct<IpPort>* dyn_match;
};

void set_specific();
void copy_value(const IpPort& other_value);
void copy_template(const IpPort_template& other_value);

public:
IpPort_template();
IpPort_template(template_sel other_value);
IpPort_template(const IpPort& other_value);
IpPort_template(const OPTIONAL<IpPort>& other_value);
IpPort_template(IpPort_template* p_precondition, IpPort_template* p_implied_template);
IpPort_template(Dynamic_Match_Interface<IpPort>* p_dyn_match);
IpPort_template(const IpPort_template& other_value);
~IpPort_template();
IpPort_template& operator=(template_sel other_value);
IpPort_template& operator=(const IpPort& other_value);
IpPort_template& operator=(const OPTIONAL<IpPort>& other_value);
IpPort_template& operator=(const IpPort_template& other_value);
boolean match(const IpPort& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
IpPort valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
IpPort_template& list_item(unsigned int list_index) const;
IpAddress_template& ip();
const IpAddress_template& ip() const;
INTEGER_template& port__();
const INTEGER_template& port__() const;
int size_of() const;
void log() const;
void log_match(const IpPort& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ResultCode : public Base_Type { // enum
friend class ResultCode_template;
public:
enum enum_type { ok = 0, illegalClientId = 1, illegalBankId = 2, illegalSlotId = 3, unsupportedProtocolVersion = 4, unknownSlotmap = 5, identityInUse = 6, cardNotPresent = 100, cardUnresponsive = 101, cardTransmissionError = 102, UNKNOWN_VALUE = 7, UNBOUND_VALUE = 8 };
private:
enum_type enum_value;

public:
ResultCode();
ResultCode(int other_value);
ResultCode(enum_type other_value);
ResultCode(const ResultCode& other_value);

ResultCode& operator=(int other_value);
ResultCode& operator=(enum_type other_value);
ResultCode& operator=(const ResultCode& other_value);

boolean operator==(enum_type other_value) const;
boolean operator==(const ResultCode& other_value) const;
inline boolean operator!=(enum_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const ResultCode& other_value) const { return !(*this == other_value); }
boolean operator<(enum_type other_value) const;
boolean operator<(const ResultCode& other_value) const;
boolean operator>(enum_type other_value) const;
boolean operator>(const ResultCode& other_value) const;
inline boolean operator<=(enum_type other_value) const { return !(*this > other_value); }
inline boolean operator<=(const ResultCode& other_value) const { return !(*this > other_value); }
inline boolean operator>=(enum_type other_value) const { return !(*this < other_value); }
inline boolean operator>=(const ResultCode& other_value) const { return !(*this < other_value); }

static const char *enum_to_str(enum_type enum_par);
static enum_type str_to_enum(const char *str_par);
static boolean is_valid_enum(int int_par);

static int enum2int(enum_type enum_par);
static int enum2int(const ResultCode& enum_par);
int as_int() const { return enum2int(enum_value); }
void from_int(int p_val) { *this = p_val; }
void int2enum(int int_val);
operator enum_type() const;
inline boolean is_bound() const { return enum_value != UNBOUND_VALUE; }
inline boolean is_value() const { return enum_value != UNBOUND_VALUE; }
inline void clean_up(){ enum_value = UNBOUND_VALUE; }
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ResultCode_template : public Base_Template {
union {
ResultCode::enum_type single_value;
struct {
unsigned int n_values;
ResultCode_template *list_value;
} value_list;
struct {
ResultCode_template* precondition;
ResultCode_template* implied_template;
} implication_;
dynmatch_struct<ResultCode>* dyn_match;
};

void copy_template(const ResultCode_template& other_value);

public:
ResultCode_template();
ResultCode_template(template_sel other_value);
ResultCode_template(int other_value);
ResultCode_template(ResultCode::enum_type other_value);
ResultCode_template(const ResultCode& other_value);
ResultCode_template(const OPTIONAL<ResultCode>& other_value);
ResultCode_template(ResultCode_template* p_precondition, ResultCode_template* p_implied_template);
ResultCode_template(Dynamic_Match_Interface<ResultCode>* p_dyn_match);
ResultCode_template(const ResultCode_template& other_value);
~ResultCode_template();

boolean is_bound() const;
boolean is_value() const;
void clean_up();
ResultCode_template& operator=(template_sel other_value);
ResultCode_template& operator=(int other_value);
ResultCode_template& operator=(ResultCode::enum_type other_value);
ResultCode_template& operator=(const ResultCode& other_value);
ResultCode_template& operator=(const OPTIONAL<ResultCode>& other_value);
ResultCode_template& operator=(const ResultCode_template& other_value);

boolean match(ResultCode::enum_type other_value, boolean legacy = FALSE) const;
boolean match(const ResultCode& other_value, boolean legacy = FALSE) const;
ResultCode::enum_type valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ResultCode_template& list_item(unsigned int list_index);
void log() const;
void log_match(const ResultCode& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class ErrorCode : public Base_Type { // enum
friend class ErrorCode_template;
public:
enum enum_type { unknownClientConnected = 1, unexpectedDisconnect = 2, unexpectedProtocolVersion = 3, UNKNOWN_VALUE = 0, UNBOUND_VALUE = 4 };
private:
enum_type enum_value;

public:
ErrorCode();
ErrorCode(int other_value);
ErrorCode(enum_type other_value);
ErrorCode(const ErrorCode& other_value);

ErrorCode& operator=(int other_value);
ErrorCode& operator=(enum_type other_value);
ErrorCode& operator=(const ErrorCode& other_value);

boolean operator==(enum_type other_value) const;
boolean operator==(const ErrorCode& other_value) const;
inline boolean operator!=(enum_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const ErrorCode& other_value) const { return !(*this == other_value); }
boolean operator<(enum_type other_value) const;
boolean operator<(const ErrorCode& other_value) const;
boolean operator>(enum_type other_value) const;
boolean operator>(const ErrorCode& other_value) const;
inline boolean operator<=(enum_type other_value) const { return !(*this > other_value); }
inline boolean operator<=(const ErrorCode& other_value) const { return !(*this > other_value); }
inline boolean operator>=(enum_type other_value) const { return !(*this < other_value); }
inline boolean operator>=(const ErrorCode& other_value) const { return !(*this < other_value); }

static const char *enum_to_str(enum_type enum_par);
static enum_type str_to_enum(const char *str_par);
static boolean is_valid_enum(int int_par);

static int enum2int(enum_type enum_par);
static int enum2int(const ErrorCode& enum_par);
int as_int() const { return enum2int(enum_value); }
void from_int(int p_val) { *this = p_val; }
void int2enum(int int_val);
operator enum_type() const;
inline boolean is_bound() const { return enum_value != UNBOUND_VALUE; }
inline boolean is_value() const { return enum_value != UNBOUND_VALUE; }
inline void clean_up(){ enum_value = UNBOUND_VALUE; }
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ErrorCode_template : public Base_Template {
union {
ErrorCode::enum_type single_value;
struct {
unsigned int n_values;
ErrorCode_template *list_value;
} value_list;
struct {
ErrorCode_template* precondition;
ErrorCode_template* implied_template;
} implication_;
dynmatch_struct<ErrorCode>* dyn_match;
};

void copy_template(const ErrorCode_template& other_value);

public:
ErrorCode_template();
ErrorCode_template(template_sel other_value);
ErrorCode_template(int other_value);
ErrorCode_template(ErrorCode::enum_type other_value);
ErrorCode_template(const ErrorCode& other_value);
ErrorCode_template(const OPTIONAL<ErrorCode>& other_value);
ErrorCode_template(ErrorCode_template* p_precondition, ErrorCode_template* p_implied_template);
ErrorCode_template(Dynamic_Match_Interface<ErrorCode>* p_dyn_match);
ErrorCode_template(const ErrorCode_template& other_value);
~ErrorCode_template();

boolean is_bound() const;
boolean is_value() const;
void clean_up();
ErrorCode_template& operator=(template_sel other_value);
ErrorCode_template& operator=(int other_value);
ErrorCode_template& operator=(ErrorCode::enum_type other_value);
ErrorCode_template& operator=(const ErrorCode& other_value);
ErrorCode_template& operator=(const OPTIONAL<ErrorCode>& other_value);
ErrorCode_template& operator=(const ErrorCode_template& other_value);

boolean match(ErrorCode::enum_type other_value, boolean legacy = FALSE) const;
boolean match(const ErrorCode& other_value, boolean legacy = FALSE) const;
ErrorCode::enum_type valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ErrorCode_template& list_item(unsigned int list_index);
void log() const;
void log_match(const ErrorCode& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class ErrorSeverity : public Base_Type { // enum
friend class ErrorSeverity_template;
public:
enum enum_type { minor_ = 1, major_ = 2, fatal = 3, UNKNOWN_VALUE = 0, UNBOUND_VALUE = 4 };
private:
enum_type enum_value;

public:
ErrorSeverity();
ErrorSeverity(int other_value);
ErrorSeverity(enum_type other_value);
ErrorSeverity(const ErrorSeverity& other_value);

ErrorSeverity& operator=(int other_value);
ErrorSeverity& operator=(enum_type other_value);
ErrorSeverity& operator=(const ErrorSeverity& other_value);

boolean operator==(enum_type other_value) const;
boolean operator==(const ErrorSeverity& other_value) const;
inline boolean operator!=(enum_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const ErrorSeverity& other_value) const { return !(*this == other_value); }
boolean operator<(enum_type other_value) const;
boolean operator<(const ErrorSeverity& other_value) const;
boolean operator>(enum_type other_value) const;
boolean operator>(const ErrorSeverity& other_value) const;
inline boolean operator<=(enum_type other_value) const { return !(*this > other_value); }
inline boolean operator<=(const ErrorSeverity& other_value) const { return !(*this > other_value); }
inline boolean operator>=(enum_type other_value) const { return !(*this < other_value); }
inline boolean operator>=(const ErrorSeverity& other_value) const { return !(*this < other_value); }

static const char *enum_to_str(enum_type enum_par);
static enum_type str_to_enum(const char *str_par);
static boolean is_valid_enum(int int_par);

static int enum2int(enum_type enum_par);
static int enum2int(const ErrorSeverity& enum_par);
int as_int() const { return enum2int(enum_value); }
void from_int(int p_val) { *this = p_val; }
void int2enum(int int_val);
operator enum_type() const;
inline boolean is_bound() const { return enum_value != UNBOUND_VALUE; }
inline boolean is_value() const { return enum_value != UNBOUND_VALUE; }
inline void clean_up(){ enum_value = UNBOUND_VALUE; }
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ErrorSeverity_template : public Base_Template {
union {
ErrorSeverity::enum_type single_value;
struct {
unsigned int n_values;
ErrorSeverity_template *list_value;
} value_list;
struct {
ErrorSeverity_template* precondition;
ErrorSeverity_template* implied_template;
} implication_;
dynmatch_struct<ErrorSeverity>* dyn_match;
};

void copy_template(const ErrorSeverity_template& other_value);

public:
ErrorSeverity_template();
ErrorSeverity_template(template_sel other_value);
ErrorSeverity_template(int other_value);
ErrorSeverity_template(ErrorSeverity::enum_type other_value);
ErrorSeverity_template(const ErrorSeverity& other_value);
ErrorSeverity_template(const OPTIONAL<ErrorSeverity>& other_value);
ErrorSeverity_template(ErrorSeverity_template* p_precondition, ErrorSeverity_template* p_implied_template);
ErrorSeverity_template(Dynamic_Match_Interface<ErrorSeverity>* p_dyn_match);
ErrorSeverity_template(const ErrorSeverity_template& other_value);
~ErrorSeverity_template();

boolean is_bound() const;
boolean is_value() const;
void clean_up();
ErrorSeverity_template& operator=(template_sel other_value);
ErrorSeverity_template& operator=(int other_value);
ErrorSeverity_template& operator=(ErrorSeverity::enum_type other_value);
ErrorSeverity_template& operator=(const ErrorSeverity& other_value);
ErrorSeverity_template& operator=(const OPTIONAL<ErrorSeverity>& other_value);
ErrorSeverity_template& operator=(const ErrorSeverity_template& other_value);

boolean match(ErrorSeverity::enum_type other_value, boolean legacy = FALSE) const;
boolean match(const ErrorSeverity& other_value, boolean legacy = FALSE) const;
ErrorSeverity::enum_type valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ErrorSeverity_template& list_item(unsigned int list_index);
void log() const;
void log_match(const ErrorSeverity& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class ClientSlot : public Base_Type {
  INTEGER field_clientId;
  INTEGER field_slotNr;
public:
  ClientSlot();
  ClientSlot(const INTEGER& par_clientId,
    const INTEGER& par_slotNr);
  ClientSlot(const ClientSlot& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ClientSlot& operator=(const ClientSlot& other_value);
  boolean operator==(const ClientSlot& other_value) const;
  inline boolean operator!=(const ClientSlot& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline INTEGER& clientId()
    {return field_clientId;}
  inline const INTEGER& clientId() const
    {return field_clientId;}
  inline INTEGER& slotNr()
    {return field_slotNr;}
  inline const INTEGER& slotNr() const
    {return field_slotNr;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ClientSlot_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ClientSlot_template *list_value;
} value_list;
struct {
ClientSlot_template* precondition;
ClientSlot_template* implied_template;
} implication_;
dynmatch_struct<ClientSlot>* dyn_match;
};

void set_specific();
void copy_value(const ClientSlot& other_value);
void copy_template(const ClientSlot_template& other_value);

public:
ClientSlot_template();
ClientSlot_template(template_sel other_value);
ClientSlot_template(const ClientSlot& other_value);
ClientSlot_template(const OPTIONAL<ClientSlot>& other_value);
ClientSlot_template(ClientSlot_template* p_precondition, ClientSlot_template* p_implied_template);
ClientSlot_template(Dynamic_Match_Interface<ClientSlot>* p_dyn_match);
ClientSlot_template(const ClientSlot_template& other_value);
~ClientSlot_template();
ClientSlot_template& operator=(template_sel other_value);
ClientSlot_template& operator=(const ClientSlot& other_value);
ClientSlot_template& operator=(const OPTIONAL<ClientSlot>& other_value);
ClientSlot_template& operator=(const ClientSlot_template& other_value);
boolean match(const ClientSlot& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ClientSlot valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ClientSlot_template& list_item(unsigned int list_index) const;
INTEGER_template& clientId();
const INTEGER_template& clientId() const;
INTEGER_template& slotNr();
const INTEGER_template& slotNr() const;
int size_of() const;
void log() const;
void log_match(const ClientSlot& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class BankSlot : public Base_Type {
  INTEGER field_bankId;
  INTEGER field_slotNr;
public:
  BankSlot();
  BankSlot(const INTEGER& par_bankId,
    const INTEGER& par_slotNr);
  BankSlot(const BankSlot& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  BankSlot& operator=(const BankSlot& other_value);
  boolean operator==(const BankSlot& other_value) const;
  inline boolean operator!=(const BankSlot& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline INTEGER& bankId()
    {return field_bankId;}
  inline const INTEGER& bankId() const
    {return field_bankId;}
  inline INTEGER& slotNr()
    {return field_slotNr;}
  inline const INTEGER& slotNr() const
    {return field_slotNr;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class BankSlot_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
BankSlot_template *list_value;
} value_list;
struct {
BankSlot_template* precondition;
BankSlot_template* implied_template;
} implication_;
dynmatch_struct<BankSlot>* dyn_match;
};

void set_specific();
void copy_value(const BankSlot& other_value);
void copy_template(const BankSlot_template& other_value);

public:
BankSlot_template();
BankSlot_template(template_sel other_value);
BankSlot_template(const BankSlot& other_value);
BankSlot_template(const OPTIONAL<BankSlot>& other_value);
BankSlot_template(BankSlot_template* p_precondition, BankSlot_template* p_implied_template);
BankSlot_template(Dynamic_Match_Interface<BankSlot>* p_dyn_match);
BankSlot_template(const BankSlot_template& other_value);
~BankSlot_template();
BankSlot_template& operator=(template_sel other_value);
BankSlot_template& operator=(const BankSlot& other_value);
BankSlot_template& operator=(const OPTIONAL<BankSlot>& other_value);
BankSlot_template& operator=(const BankSlot_template& other_value);
boolean match(const BankSlot& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
BankSlot valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
BankSlot_template& list_item(unsigned int list_index) const;
INTEGER_template& bankId();
const INTEGER_template& bankId() const;
INTEGER_template& slotNr();
const INTEGER_template& slotNr() const;
int size_of() const;
void log() const;
void log_match(const BankSlot& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class TpduFlags : public Base_Type {
  BOOLEAN field_tpduHeaderPresent;
  BOOLEAN field_finalPart;
  BOOLEAN field_procByteContinueTx;
  BOOLEAN field_procByteContinueRx;
public:
  TpduFlags();
  TpduFlags(const BOOLEAN& par_tpduHeaderPresent,
    const BOOLEAN& par_finalPart,
    const BOOLEAN& par_procByteContinueTx,
    const BOOLEAN& par_procByteContinueRx);
  TpduFlags(const TpduFlags& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  TpduFlags& operator=(const TpduFlags& other_value);
  boolean operator==(const TpduFlags& other_value) const;
  inline boolean operator!=(const TpduFlags& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline BOOLEAN& tpduHeaderPresent()
    {return field_tpduHeaderPresent;}
  inline const BOOLEAN& tpduHeaderPresent() const
    {return field_tpduHeaderPresent;}
  inline BOOLEAN& finalPart()
    {return field_finalPart;}
  inline const BOOLEAN& finalPart() const
    {return field_finalPart;}
  inline BOOLEAN& procByteContinueTx()
    {return field_procByteContinueTx;}
  inline const BOOLEAN& procByteContinueTx() const
    {return field_procByteContinueTx;}
  inline BOOLEAN& procByteContinueRx()
    {return field_procByteContinueRx;}
  inline const BOOLEAN& procByteContinueRx() const
    {return field_procByteContinueRx;}
  inline int size_of() const
    {return 4;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class TpduFlags_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
TpduFlags_template *list_value;
} value_list;
struct {
TpduFlags_template* precondition;
TpduFlags_template* implied_template;
} implication_;
dynmatch_struct<TpduFlags>* dyn_match;
};

void set_specific();
void copy_value(const TpduFlags& other_value);
void copy_template(const TpduFlags_template& other_value);

public:
TpduFlags_template();
TpduFlags_template(template_sel other_value);
TpduFlags_template(const TpduFlags& other_value);
TpduFlags_template(const OPTIONAL<TpduFlags>& other_value);
TpduFlags_template(TpduFlags_template* p_precondition, TpduFlags_template* p_implied_template);
TpduFlags_template(Dynamic_Match_Interface<TpduFlags>* p_dyn_match);
TpduFlags_template(const TpduFlags_template& other_value);
~TpduFlags_template();
TpduFlags_template& operator=(template_sel other_value);
TpduFlags_template& operator=(const TpduFlags& other_value);
TpduFlags_template& operator=(const OPTIONAL<TpduFlags>& other_value);
TpduFlags_template& operator=(const TpduFlags_template& other_value);
boolean match(const TpduFlags& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
TpduFlags valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
TpduFlags_template& list_item(unsigned int list_index) const;
BOOLEAN_template& tpduHeaderPresent();
const BOOLEAN_template& tpduHeaderPresent() const;
BOOLEAN_template& finalPart();
const BOOLEAN_template& finalPart() const;
BOOLEAN_template& procByteContinueTx();
const BOOLEAN_template& procByteContinueTx() const;
BOOLEAN_template& procByteContinueRx();
const BOOLEAN_template& procByteContinueRx() const;
int size_of() const;
void log() const;
void log_match(const TpduFlags& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class SlotPhysStatus : public Base_Type {
  BOOLEAN field_resetActive;
  OPTIONAL< BOOLEAN > field_vccPresent;
  OPTIONAL< BOOLEAN > field_clkActive;
  OPTIONAL< BOOLEAN > field_cardPresent;
public:
  SlotPhysStatus();
  SlotPhysStatus(const BOOLEAN& par_resetActive,
    const OPTIONAL< BOOLEAN >& par_vccPresent,
    const OPTIONAL< BOOLEAN >& par_clkActive,
    const OPTIONAL< BOOLEAN >& par_cardPresent);
  SlotPhysStatus(const SlotPhysStatus& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  SlotPhysStatus& operator=(const SlotPhysStatus& other_value);
  boolean operator==(const SlotPhysStatus& other_value) const;
  inline boolean operator!=(const SlotPhysStatus& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline BOOLEAN& resetActive()
    {return field_resetActive;}
  inline const BOOLEAN& resetActive() const
    {return field_resetActive;}
  inline OPTIONAL< BOOLEAN >& vccPresent()
    {return field_vccPresent;}
  inline const OPTIONAL< BOOLEAN >& vccPresent() const
    {return field_vccPresent;}
  inline OPTIONAL< BOOLEAN >& clkActive()
    {return field_clkActive;}
  inline const OPTIONAL< BOOLEAN >& clkActive() const
    {return field_clkActive;}
  inline OPTIONAL< BOOLEAN >& cardPresent()
    {return field_cardPresent;}
  inline const OPTIONAL< BOOLEAN >& cardPresent() const
    {return field_cardPresent;}
  int size_of() const;
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class SlotPhysStatus_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
SlotPhysStatus_template *list_value;
} value_list;
struct {
SlotPhysStatus_template* precondition;
SlotPhysStatus_template* implied_template;
} implication_;
dynmatch_struct<SlotPhysStatus>* dyn_match;
};

void set_specific();
void copy_value(const SlotPhysStatus& other_value);
void copy_template(const SlotPhysStatus_template& other_value);

public:
SlotPhysStatus_template();
SlotPhysStatus_template(template_sel other_value);
SlotPhysStatus_template(const SlotPhysStatus& other_value);
SlotPhysStatus_template(const OPTIONAL<SlotPhysStatus>& other_value);
SlotPhysStatus_template(SlotPhysStatus_template* p_precondition, SlotPhysStatus_template* p_implied_template);
SlotPhysStatus_template(Dynamic_Match_Interface<SlotPhysStatus>* p_dyn_match);
SlotPhysStatus_template(const SlotPhysStatus_template& other_value);
~SlotPhysStatus_template();
SlotPhysStatus_template& operator=(template_sel other_value);
SlotPhysStatus_template& operator=(const SlotPhysStatus& other_value);
SlotPhysStatus_template& operator=(const OPTIONAL<SlotPhysStatus>& other_value);
SlotPhysStatus_template& operator=(const SlotPhysStatus_template& other_value);
boolean match(const SlotPhysStatus& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
SlotPhysStatus valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
SlotPhysStatus_template& list_item(unsigned int list_index) const;
BOOLEAN_template& resetActive();
const BOOLEAN_template& resetActive() const;
BOOLEAN_template& vccPresent();
const BOOLEAN_template& vccPresent() const;
BOOLEAN_template& clkActive();
const BOOLEAN_template& clkActive() const;
BOOLEAN_template& cardPresent();
const BOOLEAN_template& cardPresent() const;
int size_of() const;
void log() const;
void log_match(const SlotPhysStatus& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConnectBankReq : public Base_Type {
  ComponentIdentity field_identity;
  INTEGER field_bankId;
  INTEGER field_numberOfSlots;
  OPTIONAL< IpPort > field_bound;
public:
  ConnectBankReq();
  ConnectBankReq(const ComponentIdentity& par_identity,
    const INTEGER& par_bankId,
    const INTEGER& par_numberOfSlots,
    const OPTIONAL< IpPort >& par_bound);
  ConnectBankReq(const ConnectBankReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConnectBankReq& operator=(const ConnectBankReq& other_value);
  boolean operator==(const ConnectBankReq& other_value) const;
  inline boolean operator!=(const ConnectBankReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ComponentIdentity& identity()
    {return field_identity;}
  inline const ComponentIdentity& identity() const
    {return field_identity;}
  inline INTEGER& bankId()
    {return field_bankId;}
  inline const INTEGER& bankId() const
    {return field_bankId;}
  inline INTEGER& numberOfSlots()
    {return field_numberOfSlots;}
  inline const INTEGER& numberOfSlots() const
    {return field_numberOfSlots;}
  inline OPTIONAL< IpPort >& bound()
    {return field_bound;}
  inline const OPTIONAL< IpPort >& bound() const
    {return field_bound;}
  int size_of() const;
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConnectBankReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConnectBankReq_template *list_value;
} value_list;
struct {
ConnectBankReq_template* precondition;
ConnectBankReq_template* implied_template;
} implication_;
dynmatch_struct<ConnectBankReq>* dyn_match;
};

void set_specific();
void copy_value(const ConnectBankReq& other_value);
void copy_template(const ConnectBankReq_template& other_value);

public:
ConnectBankReq_template();
ConnectBankReq_template(template_sel other_value);
ConnectBankReq_template(const ConnectBankReq& other_value);
ConnectBankReq_template(const OPTIONAL<ConnectBankReq>& other_value);
ConnectBankReq_template(ConnectBankReq_template* p_precondition, ConnectBankReq_template* p_implied_template);
ConnectBankReq_template(Dynamic_Match_Interface<ConnectBankReq>* p_dyn_match);
ConnectBankReq_template(const ConnectBankReq_template& other_value);
~ConnectBankReq_template();
ConnectBankReq_template& operator=(template_sel other_value);
ConnectBankReq_template& operator=(const ConnectBankReq& other_value);
ConnectBankReq_template& operator=(const OPTIONAL<ConnectBankReq>& other_value);
ConnectBankReq_template& operator=(const ConnectBankReq_template& other_value);
boolean match(const ConnectBankReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConnectBankReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConnectBankReq_template& list_item(unsigned int list_index) const;
ComponentIdentity_template& identity();
const ComponentIdentity_template& identity() const;
INTEGER_template& bankId();
const INTEGER_template& bankId() const;
INTEGER_template& numberOfSlots();
const INTEGER_template& numberOfSlots() const;
IpPort_template& bound();
const IpPort_template& bound() const;
int size_of() const;
void log() const;
void log_match(const ConnectBankReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConnectBankRes : public Base_Type {
  ComponentIdentity field_identity;
  ResultCode field_result;
public:
  ConnectBankRes();
  ConnectBankRes(const ComponentIdentity& par_identity,
    const ResultCode& par_result);
  ConnectBankRes(const ConnectBankRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConnectBankRes& operator=(const ConnectBankRes& other_value);
  boolean operator==(const ConnectBankRes& other_value) const;
  inline boolean operator!=(const ConnectBankRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ComponentIdentity& identity()
    {return field_identity;}
  inline const ComponentIdentity& identity() const
    {return field_identity;}
  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConnectBankRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConnectBankRes_template *list_value;
} value_list;
struct {
ConnectBankRes_template* precondition;
ConnectBankRes_template* implied_template;
} implication_;
dynmatch_struct<ConnectBankRes>* dyn_match;
};

void set_specific();
void copy_value(const ConnectBankRes& other_value);
void copy_template(const ConnectBankRes_template& other_value);

public:
ConnectBankRes_template();
ConnectBankRes_template(template_sel other_value);
ConnectBankRes_template(const ConnectBankRes& other_value);
ConnectBankRes_template(const OPTIONAL<ConnectBankRes>& other_value);
ConnectBankRes_template(ConnectBankRes_template* p_precondition, ConnectBankRes_template* p_implied_template);
ConnectBankRes_template(Dynamic_Match_Interface<ConnectBankRes>* p_dyn_match);
ConnectBankRes_template(const ConnectBankRes_template& other_value);
~ConnectBankRes_template();
ConnectBankRes_template& operator=(template_sel other_value);
ConnectBankRes_template& operator=(const ConnectBankRes& other_value);
ConnectBankRes_template& operator=(const OPTIONAL<ConnectBankRes>& other_value);
ConnectBankRes_template& operator=(const ConnectBankRes_template& other_value);
boolean match(const ConnectBankRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConnectBankRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConnectBankRes_template& list_item(unsigned int list_index) const;
ComponentIdentity_template& identity();
const ComponentIdentity_template& identity() const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const ConnectBankRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConnectClientReq : public Base_Type {
  ComponentIdentity field_identity;
  OPTIONAL< ClientSlot > field_clientSlot;
public:
  ConnectClientReq();
  ConnectClientReq(const ComponentIdentity& par_identity,
    const OPTIONAL< ClientSlot >& par_clientSlot);
  ConnectClientReq(const ConnectClientReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConnectClientReq& operator=(const ConnectClientReq& other_value);
  boolean operator==(const ConnectClientReq& other_value) const;
  inline boolean operator!=(const ConnectClientReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ComponentIdentity& identity()
    {return field_identity;}
  inline const ComponentIdentity& identity() const
    {return field_identity;}
  inline OPTIONAL< ClientSlot >& clientSlot()
    {return field_clientSlot;}
  inline const OPTIONAL< ClientSlot >& clientSlot() const
    {return field_clientSlot;}
  int size_of() const;
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConnectClientReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConnectClientReq_template *list_value;
} value_list;
struct {
ConnectClientReq_template* precondition;
ConnectClientReq_template* implied_template;
} implication_;
dynmatch_struct<ConnectClientReq>* dyn_match;
};

void set_specific();
void copy_value(const ConnectClientReq& other_value);
void copy_template(const ConnectClientReq_template& other_value);

public:
ConnectClientReq_template();
ConnectClientReq_template(template_sel other_value);
ConnectClientReq_template(const ConnectClientReq& other_value);
ConnectClientReq_template(const OPTIONAL<ConnectClientReq>& other_value);
ConnectClientReq_template(ConnectClientReq_template* p_precondition, ConnectClientReq_template* p_implied_template);
ConnectClientReq_template(Dynamic_Match_Interface<ConnectClientReq>* p_dyn_match);
ConnectClientReq_template(const ConnectClientReq_template& other_value);
~ConnectClientReq_template();
ConnectClientReq_template& operator=(template_sel other_value);
ConnectClientReq_template& operator=(const ConnectClientReq& other_value);
ConnectClientReq_template& operator=(const OPTIONAL<ConnectClientReq>& other_value);
ConnectClientReq_template& operator=(const ConnectClientReq_template& other_value);
boolean match(const ConnectClientReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConnectClientReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConnectClientReq_template& list_item(unsigned int list_index) const;
ComponentIdentity_template& identity();
const ComponentIdentity_template& identity() const;
ClientSlot_template& clientSlot();
const ClientSlot_template& clientSlot() const;
int size_of() const;
void log() const;
void log_match(const ConnectClientReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConnectClientRes : public Base_Type {
  ComponentIdentity field_identity;
  ResultCode field_result;
public:
  ConnectClientRes();
  ConnectClientRes(const ComponentIdentity& par_identity,
    const ResultCode& par_result);
  ConnectClientRes(const ConnectClientRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConnectClientRes& operator=(const ConnectClientRes& other_value);
  boolean operator==(const ConnectClientRes& other_value) const;
  inline boolean operator!=(const ConnectClientRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ComponentIdentity& identity()
    {return field_identity;}
  inline const ComponentIdentity& identity() const
    {return field_identity;}
  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConnectClientRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConnectClientRes_template *list_value;
} value_list;
struct {
ConnectClientRes_template* precondition;
ConnectClientRes_template* implied_template;
} implication_;
dynmatch_struct<ConnectClientRes>* dyn_match;
};

void set_specific();
void copy_value(const ConnectClientRes& other_value);
void copy_template(const ConnectClientRes_template& other_value);

public:
ConnectClientRes_template();
ConnectClientRes_template(template_sel other_value);
ConnectClientRes_template(const ConnectClientRes& other_value);
ConnectClientRes_template(const OPTIONAL<ConnectClientRes>& other_value);
ConnectClientRes_template(ConnectClientRes_template* p_precondition, ConnectClientRes_template* p_implied_template);
ConnectClientRes_template(Dynamic_Match_Interface<ConnectClientRes>* p_dyn_match);
ConnectClientRes_template(const ConnectClientRes_template& other_value);
~ConnectClientRes_template();
ConnectClientRes_template& operator=(template_sel other_value);
ConnectClientRes_template& operator=(const ConnectClientRes& other_value);
ConnectClientRes_template& operator=(const OPTIONAL<ConnectClientRes>& other_value);
ConnectClientRes_template& operator=(const ConnectClientRes_template& other_value);
boolean match(const ConnectClientRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConnectClientRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConnectClientRes_template& list_item(unsigned int list_index) const;
ComponentIdentity_template& identity();
const ComponentIdentity_template& identity() const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const ConnectClientRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class CreateMappingReq : public Base_Type {
  ClientSlot field_client;
  BankSlot field_bank;
public:
  CreateMappingReq();
  CreateMappingReq(const ClientSlot& par_client,
    const BankSlot& par_bank);
  CreateMappingReq(const CreateMappingReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  CreateMappingReq& operator=(const CreateMappingReq& other_value);
  boolean operator==(const CreateMappingReq& other_value) const;
  inline boolean operator!=(const CreateMappingReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ClientSlot& client()
    {return field_client;}
  inline const ClientSlot& client() const
    {return field_client;}
  inline BankSlot& bank()
    {return field_bank;}
  inline const BankSlot& bank() const
    {return field_bank;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class CreateMappingReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
CreateMappingReq_template *list_value;
} value_list;
struct {
CreateMappingReq_template* precondition;
CreateMappingReq_template* implied_template;
} implication_;
dynmatch_struct<CreateMappingReq>* dyn_match;
};

void set_specific();
void copy_value(const CreateMappingReq& other_value);
void copy_template(const CreateMappingReq_template& other_value);

public:
CreateMappingReq_template();
CreateMappingReq_template(template_sel other_value);
CreateMappingReq_template(const CreateMappingReq& other_value);
CreateMappingReq_template(const OPTIONAL<CreateMappingReq>& other_value);
CreateMappingReq_template(CreateMappingReq_template* p_precondition, CreateMappingReq_template* p_implied_template);
CreateMappingReq_template(Dynamic_Match_Interface<CreateMappingReq>* p_dyn_match);
CreateMappingReq_template(const CreateMappingReq_template& other_value);
~CreateMappingReq_template();
CreateMappingReq_template& operator=(template_sel other_value);
CreateMappingReq_template& operator=(const CreateMappingReq& other_value);
CreateMappingReq_template& operator=(const OPTIONAL<CreateMappingReq>& other_value);
CreateMappingReq_template& operator=(const CreateMappingReq_template& other_value);
boolean match(const CreateMappingReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
CreateMappingReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
CreateMappingReq_template& list_item(unsigned int list_index) const;
ClientSlot_template& client();
const ClientSlot_template& client() const;
BankSlot_template& bank();
const BankSlot_template& bank() const;
int size_of() const;
void log() const;
void log_match(const CreateMappingReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class CreateMappingRes : public Base_Type {
  ResultCode field_result;
public:
  CreateMappingRes();
  CreateMappingRes(const ResultCode& par_result);
  CreateMappingRes(const CreateMappingRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  CreateMappingRes& operator=(const CreateMappingRes& other_value);
  boolean operator==(const CreateMappingRes& other_value) const;
  inline boolean operator!=(const CreateMappingRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class CreateMappingRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
CreateMappingRes_template *list_value;
} value_list;
struct {
CreateMappingRes_template* precondition;
CreateMappingRes_template* implied_template;
} implication_;
dynmatch_struct<CreateMappingRes>* dyn_match;
};

void set_specific();
void copy_value(const CreateMappingRes& other_value);
void copy_template(const CreateMappingRes_template& other_value);

public:
CreateMappingRes_template();
CreateMappingRes_template(template_sel other_value);
CreateMappingRes_template(const CreateMappingRes& other_value);
CreateMappingRes_template(const OPTIONAL<CreateMappingRes>& other_value);
CreateMappingRes_template(CreateMappingRes_template* p_precondition, CreateMappingRes_template* p_implied_template);
CreateMappingRes_template(Dynamic_Match_Interface<CreateMappingRes>* p_dyn_match);
CreateMappingRes_template(const CreateMappingRes_template& other_value);
~CreateMappingRes_template();
CreateMappingRes_template& operator=(template_sel other_value);
CreateMappingRes_template& operator=(const CreateMappingRes& other_value);
CreateMappingRes_template& operator=(const OPTIONAL<CreateMappingRes>& other_value);
CreateMappingRes_template& operator=(const CreateMappingRes_template& other_value);
boolean match(const CreateMappingRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
CreateMappingRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
CreateMappingRes_template& list_item(unsigned int list_index) const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const CreateMappingRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class RemoveMappingReq : public Base_Type {
  ClientSlot field_client;
  BankSlot field_bank;
public:
  RemoveMappingReq();
  RemoveMappingReq(const ClientSlot& par_client,
    const BankSlot& par_bank);
  RemoveMappingReq(const RemoveMappingReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  RemoveMappingReq& operator=(const RemoveMappingReq& other_value);
  boolean operator==(const RemoveMappingReq& other_value) const;
  inline boolean operator!=(const RemoveMappingReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ClientSlot& client()
    {return field_client;}
  inline const ClientSlot& client() const
    {return field_client;}
  inline BankSlot& bank()
    {return field_bank;}
  inline const BankSlot& bank() const
    {return field_bank;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class RemoveMappingReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
RemoveMappingReq_template *list_value;
} value_list;
struct {
RemoveMappingReq_template* precondition;
RemoveMappingReq_template* implied_template;
} implication_;
dynmatch_struct<RemoveMappingReq>* dyn_match;
};

void set_specific();
void copy_value(const RemoveMappingReq& other_value);
void copy_template(const RemoveMappingReq_template& other_value);

public:
RemoveMappingReq_template();
RemoveMappingReq_template(template_sel other_value);
RemoveMappingReq_template(const RemoveMappingReq& other_value);
RemoveMappingReq_template(const OPTIONAL<RemoveMappingReq>& other_value);
RemoveMappingReq_template(RemoveMappingReq_template* p_precondition, RemoveMappingReq_template* p_implied_template);
RemoveMappingReq_template(Dynamic_Match_Interface<RemoveMappingReq>* p_dyn_match);
RemoveMappingReq_template(const RemoveMappingReq_template& other_value);
~RemoveMappingReq_template();
RemoveMappingReq_template& operator=(template_sel other_value);
RemoveMappingReq_template& operator=(const RemoveMappingReq& other_value);
RemoveMappingReq_template& operator=(const OPTIONAL<RemoveMappingReq>& other_value);
RemoveMappingReq_template& operator=(const RemoveMappingReq_template& other_value);
boolean match(const RemoveMappingReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
RemoveMappingReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
RemoveMappingReq_template& list_item(unsigned int list_index) const;
ClientSlot_template& client();
const ClientSlot_template& client() const;
BankSlot_template& bank();
const BankSlot_template& bank() const;
int size_of() const;
void log() const;
void log_match(const RemoveMappingReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class RemoveMappingRes : public Base_Type {
  ResultCode field_result;
public:
  RemoveMappingRes();
  RemoveMappingRes(const ResultCode& par_result);
  RemoveMappingRes(const RemoveMappingRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  RemoveMappingRes& operator=(const RemoveMappingRes& other_value);
  boolean operator==(const RemoveMappingRes& other_value) const;
  inline boolean operator!=(const RemoveMappingRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class RemoveMappingRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
RemoveMappingRes_template *list_value;
} value_list;
struct {
RemoveMappingRes_template* precondition;
RemoveMappingRes_template* implied_template;
} implication_;
dynmatch_struct<RemoveMappingRes>* dyn_match;
};

void set_specific();
void copy_value(const RemoveMappingRes& other_value);
void copy_template(const RemoveMappingRes_template& other_value);

public:
RemoveMappingRes_template();
RemoveMappingRes_template(template_sel other_value);
RemoveMappingRes_template(const RemoveMappingRes& other_value);
RemoveMappingRes_template(const OPTIONAL<RemoveMappingRes>& other_value);
RemoveMappingRes_template(RemoveMappingRes_template* p_precondition, RemoveMappingRes_template* p_implied_template);
RemoveMappingRes_template(Dynamic_Match_Interface<RemoveMappingRes>* p_dyn_match);
RemoveMappingRes_template(const RemoveMappingRes_template& other_value);
~RemoveMappingRes_template();
RemoveMappingRes_template& operator=(template_sel other_value);
RemoveMappingRes_template& operator=(const RemoveMappingRes& other_value);
RemoveMappingRes_template& operator=(const OPTIONAL<RemoveMappingRes>& other_value);
RemoveMappingRes_template& operator=(const RemoveMappingRes_template& other_value);
boolean match(const RemoveMappingRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
RemoveMappingRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
RemoveMappingRes_template& list_item(unsigned int list_index) const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const RemoveMappingRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConfigClientIdReq : public Base_Type {
  ClientSlot field_clientSlot;
public:
  ConfigClientIdReq();
  ConfigClientIdReq(const ClientSlot& par_clientSlot);
  ConfigClientIdReq(const ConfigClientIdReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConfigClientIdReq& operator=(const ConfigClientIdReq& other_value);
  boolean operator==(const ConfigClientIdReq& other_value) const;
  inline boolean operator!=(const ConfigClientIdReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ClientSlot& clientSlot()
    {return field_clientSlot;}
  inline const ClientSlot& clientSlot() const
    {return field_clientSlot;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConfigClientIdReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConfigClientIdReq_template *list_value;
} value_list;
struct {
ConfigClientIdReq_template* precondition;
ConfigClientIdReq_template* implied_template;
} implication_;
dynmatch_struct<ConfigClientIdReq>* dyn_match;
};

void set_specific();
void copy_value(const ConfigClientIdReq& other_value);
void copy_template(const ConfigClientIdReq_template& other_value);

public:
ConfigClientIdReq_template();
ConfigClientIdReq_template(template_sel other_value);
ConfigClientIdReq_template(const ConfigClientIdReq& other_value);
ConfigClientIdReq_template(const OPTIONAL<ConfigClientIdReq>& other_value);
ConfigClientIdReq_template(ConfigClientIdReq_template* p_precondition, ConfigClientIdReq_template* p_implied_template);
ConfigClientIdReq_template(Dynamic_Match_Interface<ConfigClientIdReq>* p_dyn_match);
ConfigClientIdReq_template(const ConfigClientIdReq_template& other_value);
~ConfigClientIdReq_template();
ConfigClientIdReq_template& operator=(template_sel other_value);
ConfigClientIdReq_template& operator=(const ConfigClientIdReq& other_value);
ConfigClientIdReq_template& operator=(const OPTIONAL<ConfigClientIdReq>& other_value);
ConfigClientIdReq_template& operator=(const ConfigClientIdReq_template& other_value);
boolean match(const ConfigClientIdReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConfigClientIdReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConfigClientIdReq_template& list_item(unsigned int list_index) const;
ClientSlot_template& clientSlot();
const ClientSlot_template& clientSlot() const;
int size_of() const;
void log() const;
void log_match(const ConfigClientIdReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConfigClientIdRes : public Base_Type {
  ResultCode field_result;
public:
  ConfigClientIdRes();
  ConfigClientIdRes(const ResultCode& par_result);
  ConfigClientIdRes(const ConfigClientIdRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConfigClientIdRes& operator=(const ConfigClientIdRes& other_value);
  boolean operator==(const ConfigClientIdRes& other_value) const;
  inline boolean operator!=(const ConfigClientIdRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConfigClientIdRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConfigClientIdRes_template *list_value;
} value_list;
struct {
ConfigClientIdRes_template* precondition;
ConfigClientIdRes_template* implied_template;
} implication_;
dynmatch_struct<ConfigClientIdRes>* dyn_match;
};

void set_specific();
void copy_value(const ConfigClientIdRes& other_value);
void copy_template(const ConfigClientIdRes_template& other_value);

public:
ConfigClientIdRes_template();
ConfigClientIdRes_template(template_sel other_value);
ConfigClientIdRes_template(const ConfigClientIdRes& other_value);
ConfigClientIdRes_template(const OPTIONAL<ConfigClientIdRes>& other_value);
ConfigClientIdRes_template(ConfigClientIdRes_template* p_precondition, ConfigClientIdRes_template* p_implied_template);
ConfigClientIdRes_template(Dynamic_Match_Interface<ConfigClientIdRes>* p_dyn_match);
ConfigClientIdRes_template(const ConfigClientIdRes_template& other_value);
~ConfigClientIdRes_template();
ConfigClientIdRes_template& operator=(template_sel other_value);
ConfigClientIdRes_template& operator=(const ConfigClientIdRes& other_value);
ConfigClientIdRes_template& operator=(const OPTIONAL<ConfigClientIdRes>& other_value);
ConfigClientIdRes_template& operator=(const ConfigClientIdRes_template& other_value);
boolean match(const ConfigClientIdRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConfigClientIdRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConfigClientIdRes_template& list_item(unsigned int list_index) const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const ConfigClientIdRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConfigClientBankReq : public Base_Type {
  BankSlot field_bankSlot;
  IpPort field_bankd;
public:
  ConfigClientBankReq();
  ConfigClientBankReq(const BankSlot& par_bankSlot,
    const IpPort& par_bankd);
  ConfigClientBankReq(const ConfigClientBankReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConfigClientBankReq& operator=(const ConfigClientBankReq& other_value);
  boolean operator==(const ConfigClientBankReq& other_value) const;
  inline boolean operator!=(const ConfigClientBankReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline BankSlot& bankSlot()
    {return field_bankSlot;}
  inline const BankSlot& bankSlot() const
    {return field_bankSlot;}
  inline IpPort& bankd()
    {return field_bankd;}
  inline const IpPort& bankd() const
    {return field_bankd;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConfigClientBankReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConfigClientBankReq_template *list_value;
} value_list;
struct {
ConfigClientBankReq_template* precondition;
ConfigClientBankReq_template* implied_template;
} implication_;
dynmatch_struct<ConfigClientBankReq>* dyn_match;
};

void set_specific();
void copy_value(const ConfigClientBankReq& other_value);
void copy_template(const ConfigClientBankReq_template& other_value);

public:
ConfigClientBankReq_template();
ConfigClientBankReq_template(template_sel other_value);
ConfigClientBankReq_template(const ConfigClientBankReq& other_value);
ConfigClientBankReq_template(const OPTIONAL<ConfigClientBankReq>& other_value);
ConfigClientBankReq_template(ConfigClientBankReq_template* p_precondition, ConfigClientBankReq_template* p_implied_template);
ConfigClientBankReq_template(Dynamic_Match_Interface<ConfigClientBankReq>* p_dyn_match);
ConfigClientBankReq_template(const ConfigClientBankReq_template& other_value);
~ConfigClientBankReq_template();
ConfigClientBankReq_template& operator=(template_sel other_value);
ConfigClientBankReq_template& operator=(const ConfigClientBankReq& other_value);
ConfigClientBankReq_template& operator=(const OPTIONAL<ConfigClientBankReq>& other_value);
ConfigClientBankReq_template& operator=(const ConfigClientBankReq_template& other_value);
boolean match(const ConfigClientBankReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConfigClientBankReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConfigClientBankReq_template& list_item(unsigned int list_index) const;
BankSlot_template& bankSlot();
const BankSlot_template& bankSlot() const;
IpPort_template& bankd();
const IpPort_template& bankd() const;
int size_of() const;
void log() const;
void log_match(const ConfigClientBankReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ConfigClientBankRes : public Base_Type {
  ResultCode field_result;
public:
  ConfigClientBankRes();
  ConfigClientBankRes(const ResultCode& par_result);
  ConfigClientBankRes(const ConfigClientBankRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ConfigClientBankRes& operator=(const ConfigClientBankRes& other_value);
  boolean operator==(const ConfigClientBankRes& other_value) const;
  inline boolean operator!=(const ConfigClientBankRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ConfigClientBankRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ConfigClientBankRes_template *list_value;
} value_list;
struct {
ConfigClientBankRes_template* precondition;
ConfigClientBankRes_template* implied_template;
} implication_;
dynmatch_struct<ConfigClientBankRes>* dyn_match;
};

void set_specific();
void copy_value(const ConfigClientBankRes& other_value);
void copy_template(const ConfigClientBankRes_template& other_value);

public:
ConfigClientBankRes_template();
ConfigClientBankRes_template(template_sel other_value);
ConfigClientBankRes_template(const ConfigClientBankRes& other_value);
ConfigClientBankRes_template(const OPTIONAL<ConfigClientBankRes>& other_value);
ConfigClientBankRes_template(ConfigClientBankRes_template* p_precondition, ConfigClientBankRes_template* p_implied_template);
ConfigClientBankRes_template(Dynamic_Match_Interface<ConfigClientBankRes>* p_dyn_match);
ConfigClientBankRes_template(const ConfigClientBankRes_template& other_value);
~ConfigClientBankRes_template();
ConfigClientBankRes_template& operator=(template_sel other_value);
ConfigClientBankRes_template& operator=(const ConfigClientBankRes& other_value);
ConfigClientBankRes_template& operator=(const OPTIONAL<ConfigClientBankRes>& other_value);
ConfigClientBankRes_template& operator=(const ConfigClientBankRes_template& other_value);
boolean match(const ConfigClientBankRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ConfigClientBankRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ConfigClientBankRes_template& list_item(unsigned int list_index) const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const ConfigClientBankRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class SetAtrReq : public Base_Type {
  ClientSlot field_slot;
  OCTETSTRING field_atr;
public:
  SetAtrReq();
  SetAtrReq(const ClientSlot& par_slot,
    const OCTETSTRING& par_atr);
  SetAtrReq(const SetAtrReq& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  SetAtrReq& operator=(const SetAtrReq& other_value);
  boolean operator==(const SetAtrReq& other_value) const;
  inline boolean operator!=(const SetAtrReq& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ClientSlot& slot()
    {return field_slot;}
  inline const ClientSlot& slot() const
    {return field_slot;}
  inline OCTETSTRING& atr()
    {return field_atr;}
  inline const OCTETSTRING& atr() const
    {return field_atr;}
  inline int size_of() const
    {return 2;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class SetAtrReq_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
SetAtrReq_template *list_value;
} value_list;
struct {
SetAtrReq_template* precondition;
SetAtrReq_template* implied_template;
} implication_;
dynmatch_struct<SetAtrReq>* dyn_match;
};

void set_specific();
void copy_value(const SetAtrReq& other_value);
void copy_template(const SetAtrReq_template& other_value);

public:
SetAtrReq_template();
SetAtrReq_template(template_sel other_value);
SetAtrReq_template(const SetAtrReq& other_value);
SetAtrReq_template(const OPTIONAL<SetAtrReq>& other_value);
SetAtrReq_template(SetAtrReq_template* p_precondition, SetAtrReq_template* p_implied_template);
SetAtrReq_template(Dynamic_Match_Interface<SetAtrReq>* p_dyn_match);
SetAtrReq_template(const SetAtrReq_template& other_value);
~SetAtrReq_template();
SetAtrReq_template& operator=(template_sel other_value);
SetAtrReq_template& operator=(const SetAtrReq& other_value);
SetAtrReq_template& operator=(const OPTIONAL<SetAtrReq>& other_value);
SetAtrReq_template& operator=(const SetAtrReq_template& other_value);
boolean match(const SetAtrReq& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
SetAtrReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
SetAtrReq_template& list_item(unsigned int list_index) const;
ClientSlot_template& slot();
const ClientSlot_template& slot() const;
OCTETSTRING_template& atr();
const OCTETSTRING_template& atr() const;
int size_of() const;
void log() const;
void log_match(const SetAtrReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class SetAtrRes : public Base_Type {
  ResultCode field_result;
public:
  SetAtrRes();
  SetAtrRes(const ResultCode& par_result);
  SetAtrRes(const SetAtrRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  SetAtrRes& operator=(const SetAtrRes& other_value);
  boolean operator==(const SetAtrRes& other_value) const;
  inline boolean operator!=(const SetAtrRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class SetAtrRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
SetAtrRes_template *list_value;
} value_list;
struct {
SetAtrRes_template* precondition;
SetAtrRes_template* implied_template;
} implication_;
dynmatch_struct<SetAtrRes>* dyn_match;
};

void set_specific();
void copy_value(const SetAtrRes& other_value);
void copy_template(const SetAtrRes_template& other_value);

public:
SetAtrRes_template();
SetAtrRes_template(template_sel other_value);
SetAtrRes_template(const SetAtrRes& other_value);
SetAtrRes_template(const OPTIONAL<SetAtrRes>& other_value);
SetAtrRes_template(SetAtrRes_template* p_precondition, SetAtrRes_template* p_implied_template);
SetAtrRes_template(Dynamic_Match_Interface<SetAtrRes>* p_dyn_match);
SetAtrRes_template(const SetAtrRes_template& other_value);
~SetAtrRes_template();
SetAtrRes_template& operator=(template_sel other_value);
SetAtrRes_template& operator=(const SetAtrRes& other_value);
SetAtrRes_template& operator=(const OPTIONAL<SetAtrRes>& other_value);
SetAtrRes_template& operator=(const SetAtrRes_template& other_value);
boolean match(const SetAtrRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
SetAtrRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
SetAtrRes_template& list_item(unsigned int list_index) const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const SetAtrRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class TpduModemToCard : public Base_Type {
  ClientSlot field_fromClientSlot;
  BankSlot field_toBankSlot;
  TpduFlags field_flags;
  OCTETSTRING field_data;
public:
  TpduModemToCard();
  TpduModemToCard(const ClientSlot& par_fromClientSlot,
    const BankSlot& par_toBankSlot,
    const TpduFlags& par_flags,
    const OCTETSTRING& par_data);
  TpduModemToCard(const TpduModemToCard& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  TpduModemToCard& operator=(const TpduModemToCard& other_value);
  boolean operator==(const TpduModemToCard& other_value) const;
  inline boolean operator!=(const TpduModemToCard& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ClientSlot& fromClientSlot()
    {return field_fromClientSlot;}
  inline const ClientSlot& fromClientSlot() const
    {return field_fromClientSlot;}
  inline BankSlot& toBankSlot()
    {return field_toBankSlot;}
  inline const BankSlot& toBankSlot() const
    {return field_toBankSlot;}
  inline TpduFlags& flags()
    {return field_flags;}
  inline const TpduFlags& flags() const
    {return field_flags;}
  inline OCTETSTRING& data()
    {return field_data;}
  inline const OCTETSTRING& data() const
    {return field_data;}
  inline int size_of() const
    {return 4;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class TpduModemToCard_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
TpduModemToCard_template *list_value;
} value_list;
struct {
TpduModemToCard_template* precondition;
TpduModemToCard_template* implied_template;
} implication_;
dynmatch_struct<TpduModemToCard>* dyn_match;
};

void set_specific();
void copy_value(const TpduModemToCard& other_value);
void copy_template(const TpduModemToCard_template& other_value);

public:
TpduModemToCard_template();
TpduModemToCard_template(template_sel other_value);
TpduModemToCard_template(const TpduModemToCard& other_value);
TpduModemToCard_template(const OPTIONAL<TpduModemToCard>& other_value);
TpduModemToCard_template(TpduModemToCard_template* p_precondition, TpduModemToCard_template* p_implied_template);
TpduModemToCard_template(Dynamic_Match_Interface<TpduModemToCard>* p_dyn_match);
TpduModemToCard_template(const TpduModemToCard_template& other_value);
~TpduModemToCard_template();
TpduModemToCard_template& operator=(template_sel other_value);
TpduModemToCard_template& operator=(const TpduModemToCard& other_value);
TpduModemToCard_template& operator=(const OPTIONAL<TpduModemToCard>& other_value);
TpduModemToCard_template& operator=(const TpduModemToCard_template& other_value);
boolean match(const TpduModemToCard& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
TpduModemToCard valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
TpduModemToCard_template& list_item(unsigned int list_index) const;
ClientSlot_template& fromClientSlot();
const ClientSlot_template& fromClientSlot() const;
BankSlot_template& toBankSlot();
const BankSlot_template& toBankSlot() const;
TpduFlags_template& flags();
const TpduFlags_template& flags() const;
OCTETSTRING_template& data();
const OCTETSTRING_template& data() const;
int size_of() const;
void log() const;
void log_match(const TpduModemToCard& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class TpduCardToModem : public Base_Type {
  BankSlot field_fromBankSlot;
  ClientSlot field_toClientSlot;
  TpduFlags field_flags;
  OCTETSTRING field_data;
public:
  TpduCardToModem();
  TpduCardToModem(const BankSlot& par_fromBankSlot,
    const ClientSlot& par_toClientSlot,
    const TpduFlags& par_flags,
    const OCTETSTRING& par_data);
  TpduCardToModem(const TpduCardToModem& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  TpduCardToModem& operator=(const TpduCardToModem& other_value);
  boolean operator==(const TpduCardToModem& other_value) const;
  inline boolean operator!=(const TpduCardToModem& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline BankSlot& fromBankSlot()
    {return field_fromBankSlot;}
  inline const BankSlot& fromBankSlot() const
    {return field_fromBankSlot;}
  inline ClientSlot& toClientSlot()
    {return field_toClientSlot;}
  inline const ClientSlot& toClientSlot() const
    {return field_toClientSlot;}
  inline TpduFlags& flags()
    {return field_flags;}
  inline const TpduFlags& flags() const
    {return field_flags;}
  inline OCTETSTRING& data()
    {return field_data;}
  inline const OCTETSTRING& data() const
    {return field_data;}
  inline int size_of() const
    {return 4;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class TpduCardToModem_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
TpduCardToModem_template *list_value;
} value_list;
struct {
TpduCardToModem_template* precondition;
TpduCardToModem_template* implied_template;
} implication_;
dynmatch_struct<TpduCardToModem>* dyn_match;
};

void set_specific();
void copy_value(const TpduCardToModem& other_value);
void copy_template(const TpduCardToModem_template& other_value);

public:
TpduCardToModem_template();
TpduCardToModem_template(template_sel other_value);
TpduCardToModem_template(const TpduCardToModem& other_value);
TpduCardToModem_template(const OPTIONAL<TpduCardToModem>& other_value);
TpduCardToModem_template(TpduCardToModem_template* p_precondition, TpduCardToModem_template* p_implied_template);
TpduCardToModem_template(Dynamic_Match_Interface<TpduCardToModem>* p_dyn_match);
TpduCardToModem_template(const TpduCardToModem_template& other_value);
~TpduCardToModem_template();
TpduCardToModem_template& operator=(template_sel other_value);
TpduCardToModem_template& operator=(const TpduCardToModem& other_value);
TpduCardToModem_template& operator=(const OPTIONAL<TpduCardToModem>& other_value);
TpduCardToModem_template& operator=(const TpduCardToModem_template& other_value);
boolean match(const TpduCardToModem& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
TpduCardToModem valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
TpduCardToModem_template& list_item(unsigned int list_index) const;
BankSlot_template& fromBankSlot();
const BankSlot_template& fromBankSlot() const;
ClientSlot_template& toClientSlot();
const ClientSlot_template& toClientSlot() const;
TpduFlags_template& flags();
const TpduFlags_template& flags() const;
OCTETSTRING_template& data();
const OCTETSTRING_template& data() const;
int size_of() const;
void log() const;
void log_match(const TpduCardToModem& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ClientSlotStatusInd : public Base_Type {
  ClientSlot field_fromClientSlot;
  BankSlot field_toBankSlot;
  SlotPhysStatus field_slotPhysStatus;
public:
  ClientSlotStatusInd();
  ClientSlotStatusInd(const ClientSlot& par_fromClientSlot,
    const BankSlot& par_toBankSlot,
    const SlotPhysStatus& par_slotPhysStatus);
  ClientSlotStatusInd(const ClientSlotStatusInd& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ClientSlotStatusInd& operator=(const ClientSlotStatusInd& other_value);
  boolean operator==(const ClientSlotStatusInd& other_value) const;
  inline boolean operator!=(const ClientSlotStatusInd& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ClientSlot& fromClientSlot()
    {return field_fromClientSlot;}
  inline const ClientSlot& fromClientSlot() const
    {return field_fromClientSlot;}
  inline BankSlot& toBankSlot()
    {return field_toBankSlot;}
  inline const BankSlot& toBankSlot() const
    {return field_toBankSlot;}
  inline SlotPhysStatus& slotPhysStatus()
    {return field_slotPhysStatus;}
  inline const SlotPhysStatus& slotPhysStatus() const
    {return field_slotPhysStatus;}
  inline int size_of() const
    {return 3;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ClientSlotStatusInd_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ClientSlotStatusInd_template *list_value;
} value_list;
struct {
ClientSlotStatusInd_template* precondition;
ClientSlotStatusInd_template* implied_template;
} implication_;
dynmatch_struct<ClientSlotStatusInd>* dyn_match;
};

void set_specific();
void copy_value(const ClientSlotStatusInd& other_value);
void copy_template(const ClientSlotStatusInd_template& other_value);

public:
ClientSlotStatusInd_template();
ClientSlotStatusInd_template(template_sel other_value);
ClientSlotStatusInd_template(const ClientSlotStatusInd& other_value);
ClientSlotStatusInd_template(const OPTIONAL<ClientSlotStatusInd>& other_value);
ClientSlotStatusInd_template(ClientSlotStatusInd_template* p_precondition, ClientSlotStatusInd_template* p_implied_template);
ClientSlotStatusInd_template(Dynamic_Match_Interface<ClientSlotStatusInd>* p_dyn_match);
ClientSlotStatusInd_template(const ClientSlotStatusInd_template& other_value);
~ClientSlotStatusInd_template();
ClientSlotStatusInd_template& operator=(template_sel other_value);
ClientSlotStatusInd_template& operator=(const ClientSlotStatusInd& other_value);
ClientSlotStatusInd_template& operator=(const OPTIONAL<ClientSlotStatusInd>& other_value);
ClientSlotStatusInd_template& operator=(const ClientSlotStatusInd_template& other_value);
boolean match(const ClientSlotStatusInd& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ClientSlotStatusInd valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ClientSlotStatusInd_template& list_item(unsigned int list_index) const;
ClientSlot_template& fromClientSlot();
const ClientSlot_template& fromClientSlot() const;
BankSlot_template& toBankSlot();
const BankSlot_template& toBankSlot() const;
SlotPhysStatus_template& slotPhysStatus();
const SlotPhysStatus_template& slotPhysStatus() const;
int size_of() const;
void log() const;
void log_match(const ClientSlotStatusInd& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class BankSlotStatusInd : public Base_Type {
  BankSlot field_fromBankSlot;
  ClientSlot field_toClientSlot;
  SlotPhysStatus field_slotPhysStatus;
public:
  BankSlotStatusInd();
  BankSlotStatusInd(const BankSlot& par_fromBankSlot,
    const ClientSlot& par_toClientSlot,
    const SlotPhysStatus& par_slotPhysStatus);
  BankSlotStatusInd(const BankSlotStatusInd& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  BankSlotStatusInd& operator=(const BankSlotStatusInd& other_value);
  boolean operator==(const BankSlotStatusInd& other_value) const;
  inline boolean operator!=(const BankSlotStatusInd& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline BankSlot& fromBankSlot()
    {return field_fromBankSlot;}
  inline const BankSlot& fromBankSlot() const
    {return field_fromBankSlot;}
  inline ClientSlot& toClientSlot()
    {return field_toClientSlot;}
  inline const ClientSlot& toClientSlot() const
    {return field_toClientSlot;}
  inline SlotPhysStatus& slotPhysStatus()
    {return field_slotPhysStatus;}
  inline const SlotPhysStatus& slotPhysStatus() const
    {return field_slotPhysStatus;}
  inline int size_of() const
    {return 3;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class BankSlotStatusInd_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
BankSlotStatusInd_template *list_value;
} value_list;
struct {
BankSlotStatusInd_template* precondition;
BankSlotStatusInd_template* implied_template;
} implication_;
dynmatch_struct<BankSlotStatusInd>* dyn_match;
};

void set_specific();
void copy_value(const BankSlotStatusInd& other_value);
void copy_template(const BankSlotStatusInd_template& other_value);

public:
BankSlotStatusInd_template();
BankSlotStatusInd_template(template_sel other_value);
BankSlotStatusInd_template(const BankSlotStatusInd& other_value);
BankSlotStatusInd_template(const OPTIONAL<BankSlotStatusInd>& other_value);
BankSlotStatusInd_template(BankSlotStatusInd_template* p_precondition, BankSlotStatusInd_template* p_implied_template);
BankSlotStatusInd_template(Dynamic_Match_Interface<BankSlotStatusInd>* p_dyn_match);
BankSlotStatusInd_template(const BankSlotStatusInd_template& other_value);
~BankSlotStatusInd_template();
BankSlotStatusInd_template& operator=(template_sel other_value);
BankSlotStatusInd_template& operator=(const BankSlotStatusInd& other_value);
BankSlotStatusInd_template& operator=(const OPTIONAL<BankSlotStatusInd>& other_value);
BankSlotStatusInd_template& operator=(const BankSlotStatusInd_template& other_value);
boolean match(const BankSlotStatusInd& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
BankSlotStatusInd valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
BankSlotStatusInd_template& list_item(unsigned int list_index) const;
BankSlot_template& fromBankSlot();
const BankSlot_template& fromBankSlot() const;
ClientSlot_template& toClientSlot();
const ClientSlot_template& toClientSlot() const;
SlotPhysStatus_template& slotPhysStatus();
const SlotPhysStatus_template& slotPhysStatus() const;
int size_of() const;
void log() const;
void log_match(const BankSlotStatusInd& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ErrorInd : public Base_Type {
  ComponentType field_sender__;
  ErrorSeverity field_severity;
  ErrorCode field_code;
  OPTIONAL< BankSlot > field_bankSlot;
  OPTIONAL< ClientSlot > field_clientSlot;
  OPTIONAL< CHARSTRING > field_errorString;
public:
  ErrorInd();
  ErrorInd(const ComponentType& par_sender__,
    const ErrorSeverity& par_severity,
    const ErrorCode& par_code,
    const OPTIONAL< BankSlot >& par_bankSlot,
    const OPTIONAL< ClientSlot >& par_clientSlot,
    const OPTIONAL< CHARSTRING >& par_errorString);
  ErrorInd(const ErrorInd& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ErrorInd& operator=(const ErrorInd& other_value);
  boolean operator==(const ErrorInd& other_value) const;
  inline boolean operator!=(const ErrorInd& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ComponentType& sender__()
    {return field_sender__;}
  inline const ComponentType& sender__() const
    {return field_sender__;}
  inline ErrorSeverity& severity()
    {return field_severity;}
  inline const ErrorSeverity& severity() const
    {return field_severity;}
  inline ErrorCode& code()
    {return field_code;}
  inline const ErrorCode& code() const
    {return field_code;}
  inline OPTIONAL< BankSlot >& bankSlot()
    {return field_bankSlot;}
  inline const OPTIONAL< BankSlot >& bankSlot() const
    {return field_bankSlot;}
  inline OPTIONAL< ClientSlot >& clientSlot()
    {return field_clientSlot;}
  inline const OPTIONAL< ClientSlot >& clientSlot() const
    {return field_clientSlot;}
  inline OPTIONAL< CHARSTRING >& errorString()
    {return field_errorString;}
  inline const OPTIONAL< CHARSTRING >& errorString() const
    {return field_errorString;}
  int size_of() const;
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ErrorInd_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ErrorInd_template *list_value;
} value_list;
struct {
ErrorInd_template* precondition;
ErrorInd_template* implied_template;
} implication_;
dynmatch_struct<ErrorInd>* dyn_match;
};

void set_specific();
void copy_value(const ErrorInd& other_value);
void copy_template(const ErrorInd_template& other_value);

public:
ErrorInd_template();
ErrorInd_template(template_sel other_value);
ErrorInd_template(const ErrorInd& other_value);
ErrorInd_template(const OPTIONAL<ErrorInd>& other_value);
ErrorInd_template(ErrorInd_template* p_precondition, ErrorInd_template* p_implied_template);
ErrorInd_template(Dynamic_Match_Interface<ErrorInd>* p_dyn_match);
ErrorInd_template(const ErrorInd_template& other_value);
~ErrorInd_template();
ErrorInd_template& operator=(template_sel other_value);
ErrorInd_template& operator=(const ErrorInd& other_value);
ErrorInd_template& operator=(const OPTIONAL<ErrorInd>& other_value);
ErrorInd_template& operator=(const ErrorInd_template& other_value);
boolean match(const ErrorInd& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ErrorInd valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ErrorInd_template& list_item(unsigned int list_index) const;
ComponentType_template& sender__();
const ComponentType_template& sender__() const;
ErrorSeverity_template& severity();
const ErrorSeverity_template& severity() const;
ErrorCode_template& code();
const ErrorCode_template& code() const;
BankSlot_template& bankSlot();
const BankSlot_template& bankSlot() const;
ClientSlot_template& clientSlot();
const ClientSlot_template& clientSlot() const;
CHARSTRING_template& errorString();
const CHARSTRING_template& errorString() const;
int size_of() const;
void log() const;
void log_match(const ErrorInd& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ResetStateReq : public Base_Type {
boolean bound_flag;
public:
ResetStateReq();
ResetStateReq(null_type other_value);
ResetStateReq(const ResetStateReq& other_value);
ResetStateReq& operator=(null_type other_value);
ResetStateReq& operator=(const ResetStateReq& other_value);
boolean operator==(null_type other_value) const;
boolean operator==(const ResetStateReq& other_value) const;
inline boolean operator!=(null_type other_value) const { return !(*this == other_value); }
inline boolean operator!=(const ResetStateReq& other_value) const { return !(*this == other_value); }
inline boolean is_bound() const { return bound_flag; }
inline boolean is_present() const { return is_bound(); }
inline boolean is_value() const { return bound_flag; }
inline void clean_up() { bound_flag = FALSE; }
inline void must_bound(const char *err_msg) const { if (!bound_flag) TTCN_error("%s", err_msg); }
void log() const;
void set_param(Module_Param& param);
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ResetStateReq_template : public Base_Template {
union {
struct {
unsigned int n_values;
ResetStateReq_template *list_value;
} value_list;
struct {
ResetStateReq_template* precondition;
ResetStateReq_template* implied_template;
} implication_;
dynmatch_struct<ResetStateReq>* dyn_match;
};
void copy_template(const ResetStateReq_template& other_value);

public:
ResetStateReq_template();
ResetStateReq_template(template_sel other_value);
ResetStateReq_template(null_type other_value);
ResetStateReq_template(const ResetStateReq& other_value);
ResetStateReq_template(const OPTIONAL<ResetStateReq>& other_value);
ResetStateReq_template(ResetStateReq_template* p_precondition, ResetStateReq_template* p_implied_template);
ResetStateReq_template(Dynamic_Match_Interface<ResetStateReq>* p_dyn_match);
ResetStateReq_template(const ResetStateReq_template& other_value);
~ResetStateReq_template();
void clean_up();
ResetStateReq_template& operator=(template_sel other_value);
ResetStateReq_template& operator=(null_type other_value);
ResetStateReq_template& operator=(const ResetStateReq& other_value);
ResetStateReq_template& operator=(const OPTIONAL<ResetStateReq>& other_value);
ResetStateReq_template& operator=(const ResetStateReq_template& other_value);
boolean match(null_type other_value, boolean legacy = FALSE) const;
boolean match(const ResetStateReq& other_value, boolean legacy = FALSE) const;
ResetStateReq valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ResetStateReq_template& list_item(unsigned int list_index) const;
void log() const;
void log_match(const ResetStateReq& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class ResetStateRes : public Base_Type {
  ResultCode field_result;
public:
  ResetStateRes();
  ResetStateRes(const ResultCode& par_result);
  ResetStateRes(const ResetStateRes& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  ResetStateRes& operator=(const ResetStateRes& other_value);
  boolean operator==(const ResetStateRes& other_value) const;
  inline boolean operator!=(const ResetStateRes& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline ResultCode& result()
    {return field_result;}
  inline const ResultCode& result() const
    {return field_result;}
  inline int size_of() const
    {return 1;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class ResetStateRes_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
ResetStateRes_template *list_value;
} value_list;
struct {
ResetStateRes_template* precondition;
ResetStateRes_template* implied_template;
} implication_;
dynmatch_struct<ResetStateRes>* dyn_match;
};

void set_specific();
void copy_value(const ResetStateRes& other_value);
void copy_template(const ResetStateRes_template& other_value);

public:
ResetStateRes_template();
ResetStateRes_template(template_sel other_value);
ResetStateRes_template(const ResetStateRes& other_value);
ResetStateRes_template(const OPTIONAL<ResetStateRes>& other_value);
ResetStateRes_template(ResetStateRes_template* p_precondition, ResetStateRes_template* p_implied_template);
ResetStateRes_template(Dynamic_Match_Interface<ResetStateRes>* p_dyn_match);
ResetStateRes_template(const ResetStateRes_template& other_value);
~ResetStateRes_template();
ResetStateRes_template& operator=(template_sel other_value);
ResetStateRes_template& operator=(const ResetStateRes& other_value);
ResetStateRes_template& operator=(const OPTIONAL<ResetStateRes>& other_value);
ResetStateRes_template& operator=(const ResetStateRes_template& other_value);
boolean match(const ResetStateRes& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
ResetStateRes valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
ResetStateRes_template& list_item(unsigned int list_index) const;
ResultCode_template& result();
const ResultCode_template& result() const;
int size_of() const;
void log() const;
void log_match(const ResetStateRes& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};

class RsproPDUchoice : public Base_Type {
public:
enum union_selection_type { UNBOUND_VALUE = 0, ALT_connectBankReq = 1, ALT_connectBankRes = 2, ALT_connectClientReq = 3, ALT_connectClientRes = 4, ALT_createMappingReq = 5, ALT_createMappingRes = 6, ALT_removeMappingReq = 7, ALT_removeMappingRes = 8, ALT_configClientIdReq = 9, ALT_configClientIdRes = 10, ALT_configClientBankReq = 11, ALT_configClientBankRes = 12, ALT_errorInd = 13, ALT_resetStateReq = 14, ALT_resetStateRes = 15, ALT_setAtrReq = 16, ALT_setAtrRes = 17, ALT_tpduModemToCard = 18, ALT_tpduCardToModem = 19, ALT_clientSlotStatusInd = 20, ALT_bankSlotStatusInd = 21 };
private:
union_selection_type union_selection;
union {
ConnectBankReq *field_connectBankReq;
ConnectBankRes *field_connectBankRes;
ConnectClientReq *field_connectClientReq;
ConnectClientRes *field_connectClientRes;
CreateMappingReq *field_createMappingReq;
CreateMappingRes *field_createMappingRes;
RemoveMappingReq *field_removeMappingReq;
RemoveMappingRes *field_removeMappingRes;
ConfigClientIdReq *field_configClientIdReq;
ConfigClientIdRes *field_configClientIdRes;
ConfigClientBankReq *field_configClientBankReq;
ConfigClientBankRes *field_configClientBankRes;
ErrorInd *field_errorInd;
ResetStateReq *field_resetStateReq;
ResetStateRes *field_resetStateRes;
SetAtrReq *field_setAtrReq;
SetAtrRes *field_setAtrRes;
TpduModemToCard *field_tpduModemToCard;
TpduCardToModem *field_tpduCardToModem;
ClientSlotStatusInd *field_clientSlotStatusInd;
BankSlotStatusInd *field_bankSlotStatusInd;
};
void copy_value(const RsproPDUchoice& other_value);

public:
RsproPDUchoice();
RsproPDUchoice(const RsproPDUchoice& other_value);
~RsproPDUchoice();
RsproPDUchoice& operator=(const RsproPDUchoice& other_value);
boolean operator==(const RsproPDUchoice& other_value) const;
inline boolean operator!=(const RsproPDUchoice& other_value) const { return !(*this == other_value); }
ConnectBankReq& connectBankReq();
const ConnectBankReq& connectBankReq() const;
ConnectBankRes& connectBankRes();
const ConnectBankRes& connectBankRes() const;
ConnectClientReq& connectClientReq();
const ConnectClientReq& connectClientReq() const;
ConnectClientRes& connectClientRes();
const ConnectClientRes& connectClientRes() const;
CreateMappingReq& createMappingReq();
const CreateMappingReq& createMappingReq() const;
CreateMappingRes& createMappingRes();
const CreateMappingRes& createMappingRes() const;
RemoveMappingReq& removeMappingReq();
const RemoveMappingReq& removeMappingReq() const;
RemoveMappingRes& removeMappingRes();
const RemoveMappingRes& removeMappingRes() const;
ConfigClientIdReq& configClientIdReq();
const ConfigClientIdReq& configClientIdReq() const;
ConfigClientIdRes& configClientIdRes();
const ConfigClientIdRes& configClientIdRes() const;
ConfigClientBankReq& configClientBankReq();
const ConfigClientBankReq& configClientBankReq() const;
ConfigClientBankRes& configClientBankRes();
const ConfigClientBankRes& configClientBankRes() const;
ErrorInd& errorInd();
const ErrorInd& errorInd() const;
ResetStateReq& resetStateReq();
const ResetStateReq& resetStateReq() const;
ResetStateRes& resetStateRes();
const ResetStateRes& resetStateRes() const;
SetAtrReq& setAtrReq();
const SetAtrReq& setAtrReq() const;
SetAtrRes& setAtrRes();
const SetAtrRes& setAtrRes() const;
TpduModemToCard& tpduModemToCard();
const TpduModemToCard& tpduModemToCard() const;
TpduCardToModem& tpduCardToModem();
const TpduCardToModem& tpduCardToModem() const;
ClientSlotStatusInd& clientSlotStatusInd();
const ClientSlotStatusInd& clientSlotStatusInd() const;
BankSlotStatusInd& bankSlotStatusInd();
const BankSlotStatusInd& bankSlotStatusInd() const;
inline union_selection_type get_selection() const { return union_selection; }
boolean ischosen(union_selection_type checked_selection) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
inline boolean is_present() const { return is_bound(); }
void log() const;
void set_param(Module_Param& param);
  void set_implicit_omit();
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
private:
boolean BER_decode_set_selection(const ASN_BER_TLV_t& p_tlv);
public:
boolean BER_decode_isMyMsg(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv);
};

class RsproPDUchoice_template : public Base_Template {
union {
struct {
RsproPDUchoice::union_selection_type union_selection;
union {
ConnectBankReq_template *field_connectBankReq;
ConnectBankRes_template *field_connectBankRes;
ConnectClientReq_template *field_connectClientReq;
ConnectClientRes_template *field_connectClientRes;
CreateMappingReq_template *field_createMappingReq;
CreateMappingRes_template *field_createMappingRes;
RemoveMappingReq_template *field_removeMappingReq;
RemoveMappingRes_template *field_removeMappingRes;
ConfigClientIdReq_template *field_configClientIdReq;
ConfigClientIdRes_template *field_configClientIdRes;
ConfigClientBankReq_template *field_configClientBankReq;
ConfigClientBankRes_template *field_configClientBankRes;
ErrorInd_template *field_errorInd;
ResetStateReq_template *field_resetStateReq;
ResetStateRes_template *field_resetStateRes;
SetAtrReq_template *field_setAtrReq;
SetAtrRes_template *field_setAtrRes;
TpduModemToCard_template *field_tpduModemToCard;
TpduCardToModem_template *field_tpduCardToModem;
ClientSlotStatusInd_template *field_clientSlotStatusInd;
BankSlotStatusInd_template *field_bankSlotStatusInd;
};
} single_value;
struct {
unsigned int n_values;
RsproPDUchoice_template *list_value;
} value_list;
struct {
RsproPDUchoice_template* precondition;
RsproPDUchoice_template* implied_template;
} implication_;
dynmatch_struct<RsproPDUchoice>* dyn_match;
};
void copy_value(const RsproPDUchoice& other_value);

void copy_template(const RsproPDUchoice_template& other_value);

public:
RsproPDUchoice_template();
RsproPDUchoice_template(template_sel other_value);
RsproPDUchoice_template(const RsproPDUchoice& other_value);
RsproPDUchoice_template(const OPTIONAL<RsproPDUchoice>& other_value);
RsproPDUchoice_template(RsproPDUchoice_template* p_precondition, RsproPDUchoice_template* p_implied_template);
RsproPDUchoice_template(Dynamic_Match_Interface<RsproPDUchoice>* p_dyn_match);
RsproPDUchoice_template(const RsproPDUchoice_template& other_value);
~RsproPDUchoice_template();
void clean_up();
RsproPDUchoice_template& operator=(template_sel other_value);
RsproPDUchoice_template& operator=(const RsproPDUchoice& other_value);
RsproPDUchoice_template& operator=(const OPTIONAL<RsproPDUchoice>& other_value);
RsproPDUchoice_template& operator=(const RsproPDUchoice_template& other_value);
boolean match(const RsproPDUchoice& other_value, boolean legacy = FALSE) const;
boolean is_value() const;RsproPDUchoice valueof() const;
RsproPDUchoice_template& list_item(unsigned int list_index) const;
void set_type(template_sel template_type, unsigned int list_length);
ConnectBankReq_template& connectBankReq();
const ConnectBankReq_template& connectBankReq() const;
ConnectBankRes_template& connectBankRes();
const ConnectBankRes_template& connectBankRes() const;
ConnectClientReq_template& connectClientReq();
const ConnectClientReq_template& connectClientReq() const;
ConnectClientRes_template& connectClientRes();
const ConnectClientRes_template& connectClientRes() const;
CreateMappingReq_template& createMappingReq();
const CreateMappingReq_template& createMappingReq() const;
CreateMappingRes_template& createMappingRes();
const CreateMappingRes_template& createMappingRes() const;
RemoveMappingReq_template& removeMappingReq();
const RemoveMappingReq_template& removeMappingReq() const;
RemoveMappingRes_template& removeMappingRes();
const RemoveMappingRes_template& removeMappingRes() const;
ConfigClientIdReq_template& configClientIdReq();
const ConfigClientIdReq_template& configClientIdReq() const;
ConfigClientIdRes_template& configClientIdRes();
const ConfigClientIdRes_template& configClientIdRes() const;
ConfigClientBankReq_template& configClientBankReq();
const ConfigClientBankReq_template& configClientBankReq() const;
ConfigClientBankRes_template& configClientBankRes();
const ConfigClientBankRes_template& configClientBankRes() const;
ErrorInd_template& errorInd();
const ErrorInd_template& errorInd() const;
ResetStateReq_template& resetStateReq();
const ResetStateReq_template& resetStateReq() const;
ResetStateRes_template& resetStateRes();
const ResetStateRes_template& resetStateRes() const;
SetAtrReq_template& setAtrReq();
const SetAtrReq_template& setAtrReq() const;
SetAtrRes_template& setAtrRes();
const SetAtrRes_template& setAtrRes() const;
TpduModemToCard_template& tpduModemToCard();
const TpduModemToCard_template& tpduModemToCard() const;
TpduCardToModem_template& tpduCardToModem();
const TpduCardToModem_template& tpduCardToModem() const;
ClientSlotStatusInd_template& clientSlotStatusInd();
const ClientSlotStatusInd_template& clientSlotStatusInd() const;
BankSlotStatusInd_template& bankSlotStatusInd();
const BankSlotStatusInd_template& bankSlotStatusInd() const;
boolean ischosen(RsproPDUchoice::union_selection_type checked_selection) const;
void log() const;
void log_match(const RsproPDUchoice& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
};

class RsproPDU : public Base_Type {
  INTEGER field_version;
  INTEGER field_tag;
  RsproPDUchoice field_msg;
public:
  RsproPDU();
  RsproPDU(const INTEGER& par_version,
    const INTEGER& par_tag,
    const RsproPDUchoice& par_msg);
  RsproPDU(const RsproPDU& other_value);
  inline boolean is_component() { return FALSE; }
  void clean_up();
const TTCN_Typedescriptor_t* get_descriptor() const;
  RsproPDU& operator=(const RsproPDU& other_value);
  boolean operator==(const RsproPDU& other_value) const;
  inline boolean operator!=(const RsproPDU& other_value) const
    { return !(*this == other_value); }

  boolean is_bound() const;

inline boolean is_present() const { return is_bound(); }
  boolean is_value() const;

  inline INTEGER& version()
    {return field_version;}
  inline const INTEGER& version() const
    {return field_version;}
  inline INTEGER& tag()
    {return field_tag;}
  inline const INTEGER& tag() const
    {return field_tag;}
  inline RsproPDUchoice& msg()
    {return field_msg;}
  inline const RsproPDUchoice& msg() const
    {return field_msg;}
  inline int size_of() const
    {return 3;}
  void log() const;
  void set_implicit_omit();
  void set_param(Module_Param& param);
  void encode_text(Text_Buf& text_buf) const;
  void decode_text(Text_Buf& text_buf);
void encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...) const;
void decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, int, ...);
ASN_BER_TLV_t* BER_encode_TLV(const TTCN_Typedescriptor_t& p_td, unsigned p_coding) const;
boolean BER_decode_TLV(const TTCN_Typedescriptor_t& p_td, const ASN_BER_TLV_t& p_tlv, unsigned L_form);
int JSON_encode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean) const;
int JSON_decode(const TTCN_Typedescriptor_t&, JSON_Tokenizer&, boolean, boolean, int p_chosen_field = CHOSEN_FIELD_UNSET);
int OER_encode(const TTCN_Typedescriptor_t&, TTCN_Buffer&) const;
int OER_decode(const TTCN_Typedescriptor_t&, TTCN_Buffer&, OER_struct&);
};

class RsproPDU_template : public Base_Template {
struct single_value_struct;
union {
single_value_struct *single_value;
struct {
unsigned int n_values;
RsproPDU_template *list_value;
} value_list;
struct {
RsproPDU_template* precondition;
RsproPDU_template* implied_template;
} implication_;
dynmatch_struct<RsproPDU>* dyn_match;
};

void set_specific();
void copy_value(const RsproPDU& other_value);
void copy_template(const RsproPDU_template& other_value);

public:
RsproPDU_template();
RsproPDU_template(template_sel other_value);
RsproPDU_template(const RsproPDU& other_value);
RsproPDU_template(const OPTIONAL<RsproPDU>& other_value);
RsproPDU_template(RsproPDU_template* p_precondition, RsproPDU_template* p_implied_template);
RsproPDU_template(Dynamic_Match_Interface<RsproPDU>* p_dyn_match);
RsproPDU_template(const RsproPDU_template& other_value);
~RsproPDU_template();
RsproPDU_template& operator=(template_sel other_value);
RsproPDU_template& operator=(const RsproPDU& other_value);
RsproPDU_template& operator=(const OPTIONAL<RsproPDU>& other_value);
RsproPDU_template& operator=(const RsproPDU_template& other_value);
boolean match(const RsproPDU& other_value, boolean legacy = FALSE) const;
boolean is_bound() const;
boolean is_value() const;
void clean_up();
RsproPDU valueof() const;
void set_type(template_sel template_type, unsigned int list_length);
RsproPDU_template& list_item(unsigned int list_index) const;
INTEGER_template& version();
const INTEGER_template& version() const;
INTEGER_template& tag();
const INTEGER_template& tag() const;
RsproPDUchoice_template& msg();
const RsproPDUchoice_template& msg() const;
int size_of() const;
void log() const;
void log_match(const RsproPDU& match_value, boolean legacy = FALSE) const;
void encode_text(Text_Buf& text_buf) const;
void decode_text(Text_Buf& text_buf);
void set_param(Module_Param& param);
void check_restriction(template_res t_res, const char* t_name=NULL, boolean legacy = FALSE) const;
boolean is_present(boolean legacy = FALSE) const;
boolean match_omit(boolean legacy = FALSE) const;
};


/* Function prototypes */

extern void OperationTag_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER OperationTag_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankId_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankId_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientId_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientId_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentType_encoder(const ComponentType& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentType_decoder(OCTETSTRING& input_stream, ComponentType& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentName_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentName_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_type___encoder(const ComponentType& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_type___decoder(OCTETSTRING& input_stream, ComponentType& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_name_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_name_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_software_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_software_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_swVersion_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_swVersion_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_hwManufacturer_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_hwManufacturer_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_hwModel_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_hwModel_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_hwSerialNr_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_hwSerialNr_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_hwVersion_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_hwVersion_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_fwVersion_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_fwVersion_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ComponentIdentity_encoder(const ComponentIdentity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ComponentIdentity_decoder(OCTETSTRING& input_stream, ComponentIdentity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void Ipv4Address_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER Ipv4Address_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void Ipv6Address_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER Ipv6Address_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void IpAddress_ipv4_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER IpAddress_ipv4_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void IpAddress_ipv6_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER IpAddress_ipv6_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void IpAddress_encoder(const IpAddress& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER IpAddress_decoder(OCTETSTRING& input_stream, IpAddress& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void PortNumber_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER PortNumber_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void IpPort_ip_encoder(const IpAddress& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER IpPort_ip_decoder(OCTETSTRING& input_stream, IpAddress& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void IpPort_port___encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER IpPort_port___decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void IpPort_encoder(const IpPort& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER IpPort_decoder(OCTETSTRING& input_stream, IpPort& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ResultCode_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ResultCode_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorCode_encoder(const ErrorCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorCode_decoder(OCTETSTRING& input_stream, ErrorCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorString_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorString_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorSeverity_encoder(const ErrorSeverity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorSeverity_decoder(OCTETSTRING& input_stream, ErrorSeverity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SlotNumber_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SlotNumber_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlot_clientId_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlot_clientId_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlot_slotNr_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlot_slotNr_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlot_bankId_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlot_bankId_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlot_slotNr_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlot_slotNr_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ATR_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ATR_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduFlags_tpduHeaderPresent_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduFlags_tpduHeaderPresent_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduFlags_finalPart_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduFlags_finalPart_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduFlags_procByteContinueTx_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduFlags_procByteContinueTx_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduFlags_procByteContinueRx_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduFlags_procByteContinueRx_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduFlags_encoder(const TpduFlags& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduFlags_decoder(OCTETSTRING& input_stream, TpduFlags& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SlotPhysStatus_resetActive_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SlotPhysStatus_resetActive_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SlotPhysStatus_vccPresent_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SlotPhysStatus_vccPresent_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SlotPhysStatus_clkActive_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SlotPhysStatus_clkActive_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SlotPhysStatus_cardPresent_encoder(const BOOLEAN& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SlotPhysStatus_cardPresent_decoder(OCTETSTRING& input_stream, BOOLEAN& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SlotPhysStatus_encoder(const SlotPhysStatus& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SlotPhysStatus_decoder(OCTETSTRING& input_stream, SlotPhysStatus& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankReq_identity_encoder(const ComponentIdentity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankReq_identity_decoder(OCTETSTRING& input_stream, ComponentIdentity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankReq_bankId_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankReq_bankId_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankReq_numberOfSlots_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankReq_numberOfSlots_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankReq_bound_encoder(const IpPort& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankReq_bound_decoder(OCTETSTRING& input_stream, IpPort& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankReq_encoder(const ConnectBankReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankReq_decoder(OCTETSTRING& input_stream, ConnectBankReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankRes_identity_encoder(const ComponentIdentity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankRes_identity_decoder(OCTETSTRING& input_stream, ComponentIdentity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectBankRes_encoder(const ConnectBankRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectBankRes_decoder(OCTETSTRING& input_stream, ConnectBankRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectClientReq_identity_encoder(const ComponentIdentity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectClientReq_identity_decoder(OCTETSTRING& input_stream, ComponentIdentity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectClientReq_clientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectClientReq_clientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectClientReq_encoder(const ConnectClientReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectClientReq_decoder(OCTETSTRING& input_stream, ConnectClientReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectClientRes_identity_encoder(const ComponentIdentity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectClientRes_identity_decoder(OCTETSTRING& input_stream, ComponentIdentity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectClientRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectClientRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConnectClientRes_encoder(const ConnectClientRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConnectClientRes_decoder(OCTETSTRING& input_stream, ConnectClientRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void CreateMappingReq_client_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER CreateMappingReq_client_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void CreateMappingReq_bank_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER CreateMappingReq_bank_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void CreateMappingReq_encoder(const CreateMappingReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER CreateMappingReq_decoder(OCTETSTRING& input_stream, CreateMappingReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void CreateMappingRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER CreateMappingRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void CreateMappingRes_encoder(const CreateMappingRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER CreateMappingRes_decoder(OCTETSTRING& input_stream, CreateMappingRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RemoveMappingReq_client_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RemoveMappingReq_client_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RemoveMappingReq_bank_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RemoveMappingReq_bank_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RemoveMappingReq_encoder(const RemoveMappingReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RemoveMappingReq_decoder(OCTETSTRING& input_stream, RemoveMappingReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RemoveMappingRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RemoveMappingRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RemoveMappingRes_encoder(const RemoveMappingRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RemoveMappingRes_decoder(OCTETSTRING& input_stream, RemoveMappingRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientIdReq_clientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientIdReq_clientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientIdReq_encoder(const ConfigClientIdReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientIdReq_decoder(OCTETSTRING& input_stream, ConfigClientIdReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientIdRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientIdRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientIdRes_encoder(const ConfigClientIdRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientIdRes_decoder(OCTETSTRING& input_stream, ConfigClientIdRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientBankReq_bankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientBankReq_bankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientBankReq_bankd_encoder(const IpPort& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientBankReq_bankd_decoder(OCTETSTRING& input_stream, IpPort& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientBankReq_encoder(const ConfigClientBankReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientBankReq_decoder(OCTETSTRING& input_stream, ConfigClientBankReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientBankRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientBankRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ConfigClientBankRes_encoder(const ConfigClientBankRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ConfigClientBankRes_decoder(OCTETSTRING& input_stream, ConfigClientBankRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SetAtrReq_slot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SetAtrReq_slot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SetAtrReq_atr_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SetAtrReq_atr_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SetAtrReq_encoder(const SetAtrReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SetAtrReq_decoder(OCTETSTRING& input_stream, SetAtrReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SetAtrRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SetAtrRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void SetAtrRes_encoder(const SetAtrRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER SetAtrRes_decoder(OCTETSTRING& input_stream, SetAtrRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduModemToCard_fromClientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduModemToCard_fromClientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduModemToCard_toBankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduModemToCard_toBankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduModemToCard_flags_encoder(const TpduFlags& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduModemToCard_flags_decoder(OCTETSTRING& input_stream, TpduFlags& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduModemToCard_data_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduModemToCard_data_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduModemToCard_encoder(const TpduModemToCard& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduModemToCard_decoder(OCTETSTRING& input_stream, TpduModemToCard& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduCardToModem_fromBankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduCardToModem_fromBankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduCardToModem_toClientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduCardToModem_toClientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduCardToModem_flags_encoder(const TpduFlags& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduCardToModem_flags_decoder(OCTETSTRING& input_stream, TpduFlags& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduCardToModem_data_encoder(const OCTETSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduCardToModem_data_decoder(OCTETSTRING& input_stream, OCTETSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void TpduCardToModem_encoder(const TpduCardToModem& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER TpduCardToModem_decoder(OCTETSTRING& input_stream, TpduCardToModem& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlotStatusInd_fromClientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlotStatusInd_fromClientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlotStatusInd_toBankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlotStatusInd_toBankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlotStatusInd_slotPhysStatus_encoder(const SlotPhysStatus& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlotStatusInd_slotPhysStatus_decoder(OCTETSTRING& input_stream, SlotPhysStatus& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ClientSlotStatusInd_encoder(const ClientSlotStatusInd& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ClientSlotStatusInd_decoder(OCTETSTRING& input_stream, ClientSlotStatusInd& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlotStatusInd_fromBankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlotStatusInd_fromBankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlotStatusInd_toClientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlotStatusInd_toClientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlotStatusInd_slotPhysStatus_encoder(const SlotPhysStatus& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlotStatusInd_slotPhysStatus_decoder(OCTETSTRING& input_stream, SlotPhysStatus& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void BankSlotStatusInd_encoder(const BankSlotStatusInd& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER BankSlotStatusInd_decoder(OCTETSTRING& input_stream, BankSlotStatusInd& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_sender___encoder(const ComponentType& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_sender___decoder(OCTETSTRING& input_stream, ComponentType& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_severity_encoder(const ErrorSeverity& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_severity_decoder(OCTETSTRING& input_stream, ErrorSeverity& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_code_encoder(const ErrorCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_code_decoder(OCTETSTRING& input_stream, ErrorCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_bankSlot_encoder(const BankSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_bankSlot_decoder(OCTETSTRING& input_stream, BankSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_clientSlot_encoder(const ClientSlot& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_clientSlot_decoder(OCTETSTRING& input_stream, ClientSlot& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_errorString_encoder(const CHARSTRING& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_errorString_decoder(OCTETSTRING& input_stream, CHARSTRING& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ErrorInd_encoder(const ErrorInd& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ErrorInd_decoder(OCTETSTRING& input_stream, ErrorInd& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern boolean operator==(null_type null_value, const ResetStateReq& other_value);
inline boolean operator!=(null_type null_value, const ResetStateReq& other_value) { return !(null_value == other_value); }
extern void ResetStateReq_encoder(const ResetStateReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ResetStateReq_decoder(OCTETSTRING& input_stream, ResetStateReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ResetStateRes_result_encoder(const ResultCode& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ResetStateRes_result_decoder(OCTETSTRING& input_stream, ResultCode& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void ResetStateRes_encoder(const ResetStateRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER ResetStateRes_decoder(OCTETSTRING& input_stream, ResetStateRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_connectBankReq_encoder(const ConnectBankReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_connectBankReq_decoder(OCTETSTRING& input_stream, ConnectBankReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_connectBankRes_encoder(const ConnectBankRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_connectBankRes_decoder(OCTETSTRING& input_stream, ConnectBankRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_connectClientReq_encoder(const ConnectClientReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_connectClientReq_decoder(OCTETSTRING& input_stream, ConnectClientReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_connectClientRes_encoder(const ConnectClientRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_connectClientRes_decoder(OCTETSTRING& input_stream, ConnectClientRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_createMappingReq_encoder(const CreateMappingReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_createMappingReq_decoder(OCTETSTRING& input_stream, CreateMappingReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_createMappingRes_encoder(const CreateMappingRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_createMappingRes_decoder(OCTETSTRING& input_stream, CreateMappingRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_removeMappingReq_encoder(const RemoveMappingReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_removeMappingReq_decoder(OCTETSTRING& input_stream, RemoveMappingReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_removeMappingRes_encoder(const RemoveMappingRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_removeMappingRes_decoder(OCTETSTRING& input_stream, RemoveMappingRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_configClientIdReq_encoder(const ConfigClientIdReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_configClientIdReq_decoder(OCTETSTRING& input_stream, ConfigClientIdReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_configClientIdRes_encoder(const ConfigClientIdRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_configClientIdRes_decoder(OCTETSTRING& input_stream, ConfigClientIdRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_configClientBankReq_encoder(const ConfigClientBankReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_configClientBankReq_decoder(OCTETSTRING& input_stream, ConfigClientBankReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_configClientBankRes_encoder(const ConfigClientBankRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_configClientBankRes_decoder(OCTETSTRING& input_stream, ConfigClientBankRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_errorInd_encoder(const ErrorInd& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_errorInd_decoder(OCTETSTRING& input_stream, ErrorInd& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_resetStateReq_encoder(const ResetStateReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_resetStateReq_decoder(OCTETSTRING& input_stream, ResetStateReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_resetStateRes_encoder(const ResetStateRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_resetStateRes_decoder(OCTETSTRING& input_stream, ResetStateRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_setAtrReq_encoder(const SetAtrReq& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_setAtrReq_decoder(OCTETSTRING& input_stream, SetAtrReq& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_setAtrRes_encoder(const SetAtrRes& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_setAtrRes_decoder(OCTETSTRING& input_stream, SetAtrRes& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_tpduModemToCard_encoder(const TpduModemToCard& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_tpduModemToCard_decoder(OCTETSTRING& input_stream, TpduModemToCard& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_tpduCardToModem_encoder(const TpduCardToModem& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_tpduCardToModem_decoder(OCTETSTRING& input_stream, TpduCardToModem& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_clientSlotStatusInd_encoder(const ClientSlotStatusInd& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_clientSlotStatusInd_decoder(OCTETSTRING& input_stream, ClientSlotStatusInd& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_bankSlotStatusInd_encoder(const BankSlotStatusInd& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_bankSlotStatusInd_decoder(OCTETSTRING& input_stream, BankSlotStatusInd& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDUchoice_encoder(const RsproPDUchoice& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDUchoice_decoder(OCTETSTRING& input_stream, RsproPDUchoice& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDU_version_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDU_version_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDU_tag_encoder(const INTEGER& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDU_tag_decoder(OCTETSTRING& input_stream, INTEGER& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDU_msg_encoder(const RsproPDUchoice& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDU_msg_decoder(OCTETSTRING& input_stream, RsproPDUchoice& output_value, const UNIVERSAL_CHARSTRING& coding_name);
extern void RsproPDU_encoder(const RsproPDU& input_value, OCTETSTRING& output_stream, const UNIVERSAL_CHARSTRING& coding_name);
extern INTEGER RsproPDU_decoder(OCTETSTRING& input_stream, RsproPDU& output_value, const UNIVERSAL_CHARSTRING& coding_name);

/* Global variable declarations */

extern const TTCN_OERdescriptor_t OperationTag_oer_;
extern const ASN_PERdescriptor_t OperationTag_per_;
extern const TTCN_Typedescriptor_t OperationTag_descr_;
extern UNIVERSAL_CHARSTRING OperationTag_default_coding;
extern const TTCN_OERdescriptor_t BankId_oer_;
extern const ASN_PERdescriptor_t BankId_per_;
extern const TTCN_Typedescriptor_t BankId_descr_;
extern UNIVERSAL_CHARSTRING BankId_default_coding;
extern const TTCN_OERdescriptor_t ClientId_oer_;
extern const ASN_PERdescriptor_t ClientId_per_;
extern const TTCN_Typedescriptor_t ClientId_descr_;
extern UNIVERSAL_CHARSTRING ClientId_default_coding;
extern const TTCN_JSONdescriptor_t ComponentType_json_;
extern const TTCN_OERdescriptor_t ComponentType_oer_;
extern const ASN_PERdescriptor_t ComponentType_per_;
static PerConstraint ComponentType_per_cons_;
extern const TTCN_Typedescriptor_t ComponentType_descr_;
extern UNIVERSAL_CHARSTRING ComponentType_default_coding;
extern const TTCN_Typedescriptor_t& ComponentName_descr_;
extern UNIVERSAL_CHARSTRING ComponentName_default_coding;
extern UNIVERSAL_CHARSTRING ComponentIdentity_type___default_coding;
extern UNIVERSAL_CHARSTRING ComponentIdentity_name_default_coding;
extern const ASN_BERdescriptor_t ComponentIdentity_software_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_software_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_software_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_software_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_software_default_coding;
extern const ASN_BERdescriptor_t ComponentIdentity_swVersion_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_swVersion_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_swVersion_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_swVersion_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_swVersion_default_coding;
extern const TTCN_JSONdescriptor_t ComponentIdentity_json_;
extern const TTCN_OERdescriptor_t ComponentIdentity_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_per_;
static PerConstraint ComponentIdentity_per_cons_;
extern const TTCN_Typedescriptor_t ComponentIdentity_descr_;
extern const ASN_BERdescriptor_t ComponentIdentity_hwManufacturer_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_hwManufacturer_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_hwManufacturer_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_hwManufacturer_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_hwManufacturer_default_coding;
extern const ASN_BERdescriptor_t ComponentIdentity_hwModel_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_hwModel_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_hwModel_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_hwModel_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_hwModel_default_coding;
extern const ASN_BERdescriptor_t ComponentIdentity_hwSerialNr_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_hwSerialNr_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_hwSerialNr_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_hwSerialNr_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_hwSerialNr_default_coding;
extern const ASN_BERdescriptor_t ComponentIdentity_hwVersion_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_hwVersion_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_hwVersion_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_hwVersion_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_hwVersion_default_coding;
extern const ASN_BERdescriptor_t ComponentIdentity_fwVersion_ber_;
extern const TTCN_OERdescriptor_t ComponentIdentity_fwVersion_oer_;
extern const ASN_PERdescriptor_t ComponentIdentity_fwVersion_per_;
extern const TTCN_Typedescriptor_t ComponentIdentity_fwVersion_descr_;
extern UNIVERSAL_CHARSTRING ComponentIdentity_fwVersion_default_coding;
extern UNIVERSAL_CHARSTRING ComponentIdentity_default_coding;
extern const TTCN_OERdescriptor_t Ipv4Address_oer_;
extern const ASN_PERdescriptor_t Ipv4Address_per_;
extern const TTCN_Typedescriptor_t Ipv4Address_descr_;
extern UNIVERSAL_CHARSTRING Ipv4Address_default_coding;
extern const TTCN_OERdescriptor_t Ipv6Address_oer_;
extern const ASN_PERdescriptor_t Ipv6Address_per_;
extern const TTCN_Typedescriptor_t Ipv6Address_descr_;
extern UNIVERSAL_CHARSTRING Ipv6Address_default_coding;
extern const TTCN_JSONdescriptor_t IpAddress_json_;
extern const TTCN_OERdescriptor_t IpAddress_oer_;
extern const ASN_PERdescriptor_t IpAddress_per_;
static PerConstraint IpAddress_per_cons_;
extern const TTCN_Typedescriptor_t IpAddress_descr_;
extern const ASN_BERdescriptor_t IpAddress_ipv4_ber_;
extern const TTCN_OERdescriptor_t IpAddress_ipv4_oer_;
extern const ASN_PERdescriptor_t IpAddress_ipv4_per_;
extern const TTCN_Typedescriptor_t IpAddress_ipv4_descr_;
extern UNIVERSAL_CHARSTRING IpAddress_ipv4_default_coding;
extern const ASN_BERdescriptor_t IpAddress_ipv6_ber_;
extern const TTCN_OERdescriptor_t IpAddress_ipv6_oer_;
extern const ASN_PERdescriptor_t IpAddress_ipv6_per_;
extern const TTCN_Typedescriptor_t IpAddress_ipv6_descr_;
extern UNIVERSAL_CHARSTRING IpAddress_ipv6_default_coding;
extern UNIVERSAL_CHARSTRING IpAddress_default_coding;
extern const TTCN_OERdescriptor_t PortNumber_oer_;
extern const ASN_PERdescriptor_t PortNumber_per_;
extern const TTCN_Typedescriptor_t PortNumber_descr_;
extern UNIVERSAL_CHARSTRING PortNumber_default_coding;
extern UNIVERSAL_CHARSTRING IpPort_ip_default_coding;
extern const TTCN_OERdescriptor_t IpPort_port___oer_;
extern const ASN_PERdescriptor_t IpPort_port___per_;
extern const TTCN_Typedescriptor_t IpPort_port___descr_;
extern UNIVERSAL_CHARSTRING IpPort_port___default_coding;
extern const TTCN_JSONdescriptor_t IpPort_json_;
extern const TTCN_OERdescriptor_t IpPort_oer_;
extern const ASN_PERdescriptor_t IpPort_per_;
static PerConstraint IpPort_per_cons_;
extern const TTCN_Typedescriptor_t IpPort_descr_;
extern UNIVERSAL_CHARSTRING IpPort_default_coding;
extern const TTCN_JSONdescriptor_t ResultCode_json_;
extern const TTCN_OERdescriptor_t ResultCode_oer_;
extern const ASN_PERdescriptor_t ResultCode_per_;
static PerConstraint ResultCode_per_cons_;
extern const TTCN_Typedescriptor_t ResultCode_descr_;
extern UNIVERSAL_CHARSTRING ResultCode_default_coding;
extern const TTCN_JSONdescriptor_t ErrorCode_json_;
extern const TTCN_OERdescriptor_t ErrorCode_oer_;
extern const ASN_PERdescriptor_t ErrorCode_per_;
static PerConstraint ErrorCode_per_cons_;
extern const TTCN_Typedescriptor_t ErrorCode_descr_;
extern UNIVERSAL_CHARSTRING ErrorCode_default_coding;
extern const TTCN_Typedescriptor_t& ErrorString_descr_;
extern UNIVERSAL_CHARSTRING ErrorString_default_coding;
extern const TTCN_JSONdescriptor_t ErrorSeverity_json_;
extern const TTCN_OERdescriptor_t ErrorSeverity_oer_;
extern const ASN_PERdescriptor_t ErrorSeverity_per_;
static PerConstraint ErrorSeverity_per_cons_;
extern const TTCN_Typedescriptor_t ErrorSeverity_descr_;
extern UNIVERSAL_CHARSTRING ErrorSeverity_default_coding;
extern const TTCN_OERdescriptor_t SlotNumber_oer_;
extern const ASN_PERdescriptor_t SlotNumber_per_;
extern const TTCN_Typedescriptor_t SlotNumber_descr_;
extern UNIVERSAL_CHARSTRING SlotNumber_default_coding;
extern const TTCN_OERdescriptor_t ClientSlot_clientId_oer_;
extern const ASN_PERdescriptor_t ClientSlot_clientId_per_;
extern const TTCN_Typedescriptor_t ClientSlot_clientId_descr_;
extern UNIVERSAL_CHARSTRING ClientSlot_clientId_default_coding;
extern const TTCN_OERdescriptor_t ClientSlot_slotNr_oer_;
extern const ASN_PERdescriptor_t ClientSlot_slotNr_per_;
extern const TTCN_Typedescriptor_t ClientSlot_slotNr_descr_;
extern UNIVERSAL_CHARSTRING ClientSlot_slotNr_default_coding;
extern const TTCN_JSONdescriptor_t ClientSlot_json_;
extern const TTCN_OERdescriptor_t ClientSlot_oer_;
extern const ASN_PERdescriptor_t ClientSlot_per_;
static PerConstraint ClientSlot_per_cons_;
extern const TTCN_Typedescriptor_t ClientSlot_descr_;
extern UNIVERSAL_CHARSTRING ClientSlot_default_coding;
extern const TTCN_OERdescriptor_t BankSlot_bankId_oer_;
extern const ASN_PERdescriptor_t BankSlot_bankId_per_;
extern const TTCN_Typedescriptor_t BankSlot_bankId_descr_;
extern UNIVERSAL_CHARSTRING BankSlot_bankId_default_coding;
extern const TTCN_OERdescriptor_t BankSlot_slotNr_oer_;
extern const ASN_PERdescriptor_t BankSlot_slotNr_per_;
extern const TTCN_Typedescriptor_t BankSlot_slotNr_descr_;
extern UNIVERSAL_CHARSTRING BankSlot_slotNr_default_coding;
extern const TTCN_JSONdescriptor_t BankSlot_json_;
extern const TTCN_OERdescriptor_t BankSlot_oer_;
extern const ASN_PERdescriptor_t BankSlot_per_;
static PerConstraint BankSlot_per_cons_;
extern const TTCN_Typedescriptor_t BankSlot_descr_;
extern UNIVERSAL_CHARSTRING BankSlot_default_coding;
extern const TTCN_OERdescriptor_t ATR_oer_;
extern const ASN_PERdescriptor_t ATR_per_;
extern const TTCN_Typedescriptor_t ATR_descr_;
extern UNIVERSAL_CHARSTRING ATR_default_coding;
extern UNIVERSAL_CHARSTRING TpduFlags_tpduHeaderPresent_default_coding;
extern UNIVERSAL_CHARSTRING TpduFlags_finalPart_default_coding;
extern UNIVERSAL_CHARSTRING TpduFlags_procByteContinueTx_default_coding;
extern UNIVERSAL_CHARSTRING TpduFlags_procByteContinueRx_default_coding;
extern const TTCN_JSONdescriptor_t TpduFlags_json_;
extern const TTCN_OERdescriptor_t TpduFlags_oer_;
extern const ASN_PERdescriptor_t TpduFlags_per_;
static PerConstraint TpduFlags_per_cons_;
extern const TTCN_Typedescriptor_t TpduFlags_descr_;
extern UNIVERSAL_CHARSTRING TpduFlags_default_coding;
extern const ASN_BERdescriptor_t SlotPhysStatus_resetActive_ber_;
extern const TTCN_OERdescriptor_t SlotPhysStatus_resetActive_oer_;
extern const ASN_PERdescriptor_t SlotPhysStatus_resetActive_per_;
static PerConstraint SlotPhysStatus_resetActive_per_cons_;
extern const TTCN_Typedescriptor_t SlotPhysStatus_resetActive_descr_;
extern UNIVERSAL_CHARSTRING SlotPhysStatus_resetActive_default_coding;
extern const TTCN_JSONdescriptor_t SlotPhysStatus_json_;
extern const TTCN_OERdescriptor_t SlotPhysStatus_oer_;
extern const ASN_PERdescriptor_t SlotPhysStatus_per_;
static PerConstraint SlotPhysStatus_per_cons_;
extern const TTCN_Typedescriptor_t SlotPhysStatus_descr_;
extern const ASN_BERdescriptor_t SlotPhysStatus_vccPresent_ber_;
extern const TTCN_OERdescriptor_t SlotPhysStatus_vccPresent_oer_;
extern const ASN_PERdescriptor_t SlotPhysStatus_vccPresent_per_;
static PerConstraint SlotPhysStatus_vccPresent_per_cons_;
extern const TTCN_Typedescriptor_t SlotPhysStatus_vccPresent_descr_;
extern UNIVERSAL_CHARSTRING SlotPhysStatus_vccPresent_default_coding;
extern const ASN_BERdescriptor_t SlotPhysStatus_clkActive_ber_;
extern const TTCN_OERdescriptor_t SlotPhysStatus_clkActive_oer_;
extern const ASN_PERdescriptor_t SlotPhysStatus_clkActive_per_;
static PerConstraint SlotPhysStatus_clkActive_per_cons_;
extern const TTCN_Typedescriptor_t SlotPhysStatus_clkActive_descr_;
extern UNIVERSAL_CHARSTRING SlotPhysStatus_clkActive_default_coding;
extern const ASN_BERdescriptor_t SlotPhysStatus_cardPresent_ber_;
extern const TTCN_OERdescriptor_t SlotPhysStatus_cardPresent_oer_;
extern const ASN_PERdescriptor_t SlotPhysStatus_cardPresent_per_;
static PerConstraint SlotPhysStatus_cardPresent_per_cons_;
extern const TTCN_Typedescriptor_t SlotPhysStatus_cardPresent_descr_;
extern UNIVERSAL_CHARSTRING SlotPhysStatus_cardPresent_default_coding;
extern UNIVERSAL_CHARSTRING SlotPhysStatus_default_coding;
extern const TTCN_OERdescriptor_t ConnectBankReq_identity_oer_;
extern const ASN_PERdescriptor_t ConnectBankReq_identity_per_;
static PerConstraint ConnectBankReq_identity_per_cons_;
extern const TTCN_Typedescriptor_t ConnectBankReq_identity_descr_;
extern UNIVERSAL_CHARSTRING ConnectBankReq_identity_default_coding;
extern const TTCN_OERdescriptor_t ConnectBankReq_bankId_oer_;
extern const ASN_PERdescriptor_t ConnectBankReq_bankId_per_;
extern const TTCN_Typedescriptor_t ConnectBankReq_bankId_descr_;
extern UNIVERSAL_CHARSTRING ConnectBankReq_bankId_default_coding;
extern const TTCN_OERdescriptor_t ConnectBankReq_numberOfSlots_oer_;
extern const ASN_PERdescriptor_t ConnectBankReq_numberOfSlots_per_;
extern const TTCN_Typedescriptor_t ConnectBankReq_numberOfSlots_descr_;
extern UNIVERSAL_CHARSTRING ConnectBankReq_numberOfSlots_default_coding;
extern const TTCN_JSONdescriptor_t ConnectBankReq_json_;
extern const TTCN_OERdescriptor_t ConnectBankReq_oer_;
extern const ASN_PERdescriptor_t ConnectBankReq_per_;
static PerConstraint ConnectBankReq_per_cons_;
extern const TTCN_Typedescriptor_t ConnectBankReq_descr_;
extern const TTCN_OERdescriptor_t ConnectBankReq_bound_oer_;
extern const ASN_PERdescriptor_t ConnectBankReq_bound_per_;
static PerConstraint ConnectBankReq_bound_per_cons_;
extern const TTCN_Typedescriptor_t ConnectBankReq_bound_descr_;
extern UNIVERSAL_CHARSTRING ConnectBankReq_bound_default_coding;
extern UNIVERSAL_CHARSTRING ConnectBankReq_default_coding;
extern const TTCN_OERdescriptor_t ConnectBankRes_identity_oer_;
extern const ASN_PERdescriptor_t ConnectBankRes_identity_per_;
static PerConstraint ConnectBankRes_identity_per_cons_;
extern const TTCN_Typedescriptor_t ConnectBankRes_identity_descr_;
extern UNIVERSAL_CHARSTRING ConnectBankRes_identity_default_coding;
extern UNIVERSAL_CHARSTRING ConnectBankRes_result_default_coding;
extern const TTCN_JSONdescriptor_t ConnectBankRes_json_;
extern const TTCN_OERdescriptor_t ConnectBankRes_oer_;
extern const ASN_PERdescriptor_t ConnectBankRes_per_;
static PerConstraint ConnectBankRes_per_cons_;
extern const TTCN_Typedescriptor_t ConnectBankRes_descr_;
extern UNIVERSAL_CHARSTRING ConnectBankRes_default_coding;
extern const TTCN_OERdescriptor_t ConnectClientReq_identity_oer_;
extern const ASN_PERdescriptor_t ConnectClientReq_identity_per_;
static PerConstraint ConnectClientReq_identity_per_cons_;
extern const TTCN_Typedescriptor_t ConnectClientReq_identity_descr_;
extern UNIVERSAL_CHARSTRING ConnectClientReq_identity_default_coding;
extern const TTCN_JSONdescriptor_t ConnectClientReq_json_;
extern const TTCN_OERdescriptor_t ConnectClientReq_oer_;
extern const ASN_PERdescriptor_t ConnectClientReq_per_;
static PerConstraint ConnectClientReq_per_cons_;
extern const TTCN_Typedescriptor_t ConnectClientReq_descr_;
extern const TTCN_OERdescriptor_t ConnectClientReq_clientSlot_oer_;
extern const ASN_PERdescriptor_t ConnectClientReq_clientSlot_per_;
static PerConstraint ConnectClientReq_clientSlot_per_cons_;
extern const TTCN_Typedescriptor_t ConnectClientReq_clientSlot_descr_;
extern UNIVERSAL_CHARSTRING ConnectClientReq_clientSlot_default_coding;
extern UNIVERSAL_CHARSTRING ConnectClientReq_default_coding;
extern const TTCN_OERdescriptor_t ConnectClientRes_identity_oer_;
extern const ASN_PERdescriptor_t ConnectClientRes_identity_per_;
static PerConstraint ConnectClientRes_identity_per_cons_;
extern const TTCN_Typedescriptor_t ConnectClientRes_identity_descr_;
extern UNIVERSAL_CHARSTRING ConnectClientRes_identity_default_coding;
extern UNIVERSAL_CHARSTRING ConnectClientRes_result_default_coding;
extern const TTCN_JSONdescriptor_t ConnectClientRes_json_;
extern const TTCN_OERdescriptor_t ConnectClientRes_oer_;
extern const ASN_PERdescriptor_t ConnectClientRes_per_;
static PerConstraint ConnectClientRes_per_cons_;
extern const TTCN_Typedescriptor_t ConnectClientRes_descr_;
extern UNIVERSAL_CHARSTRING ConnectClientRes_default_coding;
extern const TTCN_OERdescriptor_t CreateMappingReq_client_oer_;
extern const ASN_PERdescriptor_t CreateMappingReq_client_per_;
static PerConstraint CreateMappingReq_client_per_cons_;
extern const TTCN_Typedescriptor_t CreateMappingReq_client_descr_;
extern UNIVERSAL_CHARSTRING CreateMappingReq_client_default_coding;
extern const TTCN_OERdescriptor_t CreateMappingReq_bank_oer_;
extern const ASN_PERdescriptor_t CreateMappingReq_bank_per_;
static PerConstraint CreateMappingReq_bank_per_cons_;
extern const TTCN_Typedescriptor_t CreateMappingReq_bank_descr_;
extern UNIVERSAL_CHARSTRING CreateMappingReq_bank_default_coding;
extern const TTCN_JSONdescriptor_t CreateMappingReq_json_;
extern const TTCN_OERdescriptor_t CreateMappingReq_oer_;
extern const ASN_PERdescriptor_t CreateMappingReq_per_;
static PerConstraint CreateMappingReq_per_cons_;
extern const TTCN_Typedescriptor_t CreateMappingReq_descr_;
extern UNIVERSAL_CHARSTRING CreateMappingReq_default_coding;
extern UNIVERSAL_CHARSTRING CreateMappingRes_result_default_coding;
extern const TTCN_JSONdescriptor_t CreateMappingRes_json_;
extern const TTCN_OERdescriptor_t CreateMappingRes_oer_;
extern const ASN_PERdescriptor_t CreateMappingRes_per_;
static PerConstraint CreateMappingRes_per_cons_;
extern const TTCN_Typedescriptor_t CreateMappingRes_descr_;
extern UNIVERSAL_CHARSTRING CreateMappingRes_default_coding;
extern const TTCN_OERdescriptor_t RemoveMappingReq_client_oer_;
extern const ASN_PERdescriptor_t RemoveMappingReq_client_per_;
static PerConstraint RemoveMappingReq_client_per_cons_;
extern const TTCN_Typedescriptor_t RemoveMappingReq_client_descr_;
extern UNIVERSAL_CHARSTRING RemoveMappingReq_client_default_coding;
extern const TTCN_OERdescriptor_t RemoveMappingReq_bank_oer_;
extern const ASN_PERdescriptor_t RemoveMappingReq_bank_per_;
static PerConstraint RemoveMappingReq_bank_per_cons_;
extern const TTCN_Typedescriptor_t RemoveMappingReq_bank_descr_;
extern UNIVERSAL_CHARSTRING RemoveMappingReq_bank_default_coding;
extern const TTCN_JSONdescriptor_t RemoveMappingReq_json_;
extern const TTCN_OERdescriptor_t RemoveMappingReq_oer_;
extern const ASN_PERdescriptor_t RemoveMappingReq_per_;
static PerConstraint RemoveMappingReq_per_cons_;
extern const TTCN_Typedescriptor_t RemoveMappingReq_descr_;
extern UNIVERSAL_CHARSTRING RemoveMappingReq_default_coding;
extern UNIVERSAL_CHARSTRING RemoveMappingRes_result_default_coding;
extern const TTCN_JSONdescriptor_t RemoveMappingRes_json_;
extern const TTCN_OERdescriptor_t RemoveMappingRes_oer_;
extern const ASN_PERdescriptor_t RemoveMappingRes_per_;
static PerConstraint RemoveMappingRes_per_cons_;
extern const TTCN_Typedescriptor_t RemoveMappingRes_descr_;
extern UNIVERSAL_CHARSTRING RemoveMappingRes_default_coding;
extern const TTCN_OERdescriptor_t ConfigClientIdReq_clientSlot_oer_;
extern const ASN_PERdescriptor_t ConfigClientIdReq_clientSlot_per_;
static PerConstraint ConfigClientIdReq_clientSlot_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientIdReq_clientSlot_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientIdReq_clientSlot_default_coding;
extern const TTCN_JSONdescriptor_t ConfigClientIdReq_json_;
extern const TTCN_OERdescriptor_t ConfigClientIdReq_oer_;
extern const ASN_PERdescriptor_t ConfigClientIdReq_per_;
static PerConstraint ConfigClientIdReq_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientIdReq_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientIdReq_default_coding;
extern UNIVERSAL_CHARSTRING ConfigClientIdRes_result_default_coding;
extern const TTCN_JSONdescriptor_t ConfigClientIdRes_json_;
extern const TTCN_OERdescriptor_t ConfigClientIdRes_oer_;
extern const ASN_PERdescriptor_t ConfigClientIdRes_per_;
static PerConstraint ConfigClientIdRes_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientIdRes_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientIdRes_default_coding;
extern const TTCN_OERdescriptor_t ConfigClientBankReq_bankSlot_oer_;
extern const ASN_PERdescriptor_t ConfigClientBankReq_bankSlot_per_;
static PerConstraint ConfigClientBankReq_bankSlot_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientBankReq_bankSlot_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientBankReq_bankSlot_default_coding;
extern const TTCN_OERdescriptor_t ConfigClientBankReq_bankd_oer_;
extern const ASN_PERdescriptor_t ConfigClientBankReq_bankd_per_;
static PerConstraint ConfigClientBankReq_bankd_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientBankReq_bankd_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientBankReq_bankd_default_coding;
extern const TTCN_JSONdescriptor_t ConfigClientBankReq_json_;
extern const TTCN_OERdescriptor_t ConfigClientBankReq_oer_;
extern const ASN_PERdescriptor_t ConfigClientBankReq_per_;
static PerConstraint ConfigClientBankReq_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientBankReq_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientBankReq_default_coding;
extern UNIVERSAL_CHARSTRING ConfigClientBankRes_result_default_coding;
extern const TTCN_JSONdescriptor_t ConfigClientBankRes_json_;
extern const TTCN_OERdescriptor_t ConfigClientBankRes_oer_;
extern const ASN_PERdescriptor_t ConfigClientBankRes_per_;
static PerConstraint ConfigClientBankRes_per_cons_;
extern const TTCN_Typedescriptor_t ConfigClientBankRes_descr_;
extern UNIVERSAL_CHARSTRING ConfigClientBankRes_default_coding;
extern const TTCN_OERdescriptor_t SetAtrReq_slot_oer_;
extern const ASN_PERdescriptor_t SetAtrReq_slot_per_;
static PerConstraint SetAtrReq_slot_per_cons_;
extern const TTCN_Typedescriptor_t SetAtrReq_slot_descr_;
extern UNIVERSAL_CHARSTRING SetAtrReq_slot_default_coding;
extern const TTCN_OERdescriptor_t SetAtrReq_atr_oer_;
extern const ASN_PERdescriptor_t SetAtrReq_atr_per_;
extern const TTCN_Typedescriptor_t SetAtrReq_atr_descr_;
extern UNIVERSAL_CHARSTRING SetAtrReq_atr_default_coding;
extern const TTCN_JSONdescriptor_t SetAtrReq_json_;
extern const TTCN_OERdescriptor_t SetAtrReq_oer_;
extern const ASN_PERdescriptor_t SetAtrReq_per_;
static PerConstraint SetAtrReq_per_cons_;
extern const TTCN_Typedescriptor_t SetAtrReq_descr_;
extern UNIVERSAL_CHARSTRING SetAtrReq_default_coding;
extern UNIVERSAL_CHARSTRING SetAtrRes_result_default_coding;
extern const TTCN_JSONdescriptor_t SetAtrRes_json_;
extern const TTCN_OERdescriptor_t SetAtrRes_oer_;
extern const ASN_PERdescriptor_t SetAtrRes_per_;
static PerConstraint SetAtrRes_per_cons_;
extern const TTCN_Typedescriptor_t SetAtrRes_descr_;
extern UNIVERSAL_CHARSTRING SetAtrRes_default_coding;
extern const TTCN_OERdescriptor_t TpduModemToCard_fromClientSlot_oer_;
extern const ASN_PERdescriptor_t TpduModemToCard_fromClientSlot_per_;
static PerConstraint TpduModemToCard_fromClientSlot_per_cons_;
extern const TTCN_Typedescriptor_t TpduModemToCard_fromClientSlot_descr_;
extern UNIVERSAL_CHARSTRING TpduModemToCard_fromClientSlot_default_coding;
extern const TTCN_OERdescriptor_t TpduModemToCard_toBankSlot_oer_;
extern const ASN_PERdescriptor_t TpduModemToCard_toBankSlot_per_;
static PerConstraint TpduModemToCard_toBankSlot_per_cons_;
extern const TTCN_Typedescriptor_t TpduModemToCard_toBankSlot_descr_;
extern UNIVERSAL_CHARSTRING TpduModemToCard_toBankSlot_default_coding;
extern const TTCN_OERdescriptor_t TpduModemToCard_flags_oer_;
extern const ASN_PERdescriptor_t TpduModemToCard_flags_per_;
static PerConstraint TpduModemToCard_flags_per_cons_;
extern const TTCN_Typedescriptor_t TpduModemToCard_flags_descr_;
extern UNIVERSAL_CHARSTRING TpduModemToCard_flags_default_coding;
extern UNIVERSAL_CHARSTRING TpduModemToCard_data_default_coding;
extern const TTCN_JSONdescriptor_t TpduModemToCard_json_;
extern const TTCN_OERdescriptor_t TpduModemToCard_oer_;
extern const ASN_PERdescriptor_t TpduModemToCard_per_;
static PerConstraint TpduModemToCard_per_cons_;
extern const TTCN_Typedescriptor_t TpduModemToCard_descr_;
extern UNIVERSAL_CHARSTRING TpduModemToCard_default_coding;
extern const TTCN_OERdescriptor_t TpduCardToModem_fromBankSlot_oer_;
extern const ASN_PERdescriptor_t TpduCardToModem_fromBankSlot_per_;
static PerConstraint TpduCardToModem_fromBankSlot_per_cons_;
extern const TTCN_Typedescriptor_t TpduCardToModem_fromBankSlot_descr_;
extern UNIVERSAL_CHARSTRING TpduCardToModem_fromBankSlot_default_coding;
extern const TTCN_OERdescriptor_t TpduCardToModem_toClientSlot_oer_;
extern const ASN_PERdescriptor_t TpduCardToModem_toClientSlot_per_;
static PerConstraint TpduCardToModem_toClientSlot_per_cons_;
extern const TTCN_Typedescriptor_t TpduCardToModem_toClientSlot_descr_;
extern UNIVERSAL_CHARSTRING TpduCardToModem_toClientSlot_default_coding;
extern const TTCN_OERdescriptor_t TpduCardToModem_flags_oer_;
extern const ASN_PERdescriptor_t TpduCardToModem_flags_per_;
static PerConstraint TpduCardToModem_flags_per_cons_;
extern const TTCN_Typedescriptor_t TpduCardToModem_flags_descr_;
extern UNIVERSAL_CHARSTRING TpduCardToModem_flags_default_coding;
extern UNIVERSAL_CHARSTRING TpduCardToModem_data_default_coding;
extern const TTCN_JSONdescriptor_t TpduCardToModem_json_;
extern const TTCN_OERdescriptor_t TpduCardToModem_oer_;
extern const ASN_PERdescriptor_t TpduCardToModem_per_;
static PerConstraint TpduCardToModem_per_cons_;
extern const TTCN_Typedescriptor_t TpduCardToModem_descr_;
extern UNIVERSAL_CHARSTRING TpduCardToModem_default_coding;
extern const TTCN_OERdescriptor_t ClientSlotStatusInd_fromClientSlot_oer_;
extern const ASN_PERdescriptor_t ClientSlotStatusInd_fromClientSlot_per_;
static PerConstraint ClientSlotStatusInd_fromClientSlot_per_cons_;
extern const TTCN_Typedescriptor_t ClientSlotStatusInd_fromClientSlot_descr_;
extern UNIVERSAL_CHARSTRING ClientSlotStatusInd_fromClientSlot_default_coding;
extern const TTCN_OERdescriptor_t ClientSlotStatusInd_toBankSlot_oer_;
extern const ASN_PERdescriptor_t ClientSlotStatusInd_toBankSlot_per_;
static PerConstraint ClientSlotStatusInd_toBankSlot_per_cons_;
extern const TTCN_Typedescriptor_t ClientSlotStatusInd_toBankSlot_descr_;
extern UNIVERSAL_CHARSTRING ClientSlotStatusInd_toBankSlot_default_coding;
extern const TTCN_OERdescriptor_t ClientSlotStatusInd_slotPhysStatus_oer_;
extern const ASN_PERdescriptor_t ClientSlotStatusInd_slotPhysStatus_per_;
static PerConstraint ClientSlotStatusInd_slotPhysStatus_per_cons_;
extern const TTCN_Typedescriptor_t ClientSlotStatusInd_slotPhysStatus_descr_;
extern UNIVERSAL_CHARSTRING ClientSlotStatusInd_slotPhysStatus_default_coding;
extern const TTCN_JSONdescriptor_t ClientSlotStatusInd_json_;
extern const TTCN_OERdescriptor_t ClientSlotStatusInd_oer_;
extern const ASN_PERdescriptor_t ClientSlotStatusInd_per_;
static PerConstraint ClientSlotStatusInd_per_cons_;
extern const TTCN_Typedescriptor_t ClientSlotStatusInd_descr_;
extern UNIVERSAL_CHARSTRING ClientSlotStatusInd_default_coding;
extern const TTCN_OERdescriptor_t BankSlotStatusInd_fromBankSlot_oer_;
extern const ASN_PERdescriptor_t BankSlotStatusInd_fromBankSlot_per_;
static PerConstraint BankSlotStatusInd_fromBankSlot_per_cons_;
extern const TTCN_Typedescriptor_t BankSlotStatusInd_fromBankSlot_descr_;
extern UNIVERSAL_CHARSTRING BankSlotStatusInd_fromBankSlot_default_coding;
extern const TTCN_OERdescriptor_t BankSlotStatusInd_toClientSlot_oer_;
extern const ASN_PERdescriptor_t BankSlotStatusInd_toClientSlot_per_;
static PerConstraint BankSlotStatusInd_toClientSlot_per_cons_;
extern const TTCN_Typedescriptor_t BankSlotStatusInd_toClientSlot_descr_;
extern UNIVERSAL_CHARSTRING BankSlotStatusInd_toClientSlot_default_coding;
extern const TTCN_OERdescriptor_t BankSlotStatusInd_slotPhysStatus_oer_;
extern const ASN_PERdescriptor_t BankSlotStatusInd_slotPhysStatus_per_;
static PerConstraint BankSlotStatusInd_slotPhysStatus_per_cons_;
extern const TTCN_Typedescriptor_t BankSlotStatusInd_slotPhysStatus_descr_;
extern UNIVERSAL_CHARSTRING BankSlotStatusInd_slotPhysStatus_default_coding;
extern const TTCN_JSONdescriptor_t BankSlotStatusInd_json_;
extern const TTCN_OERdescriptor_t BankSlotStatusInd_oer_;
extern const ASN_PERdescriptor_t BankSlotStatusInd_per_;
static PerConstraint BankSlotStatusInd_per_cons_;
extern const TTCN_Typedescriptor_t BankSlotStatusInd_descr_;
extern UNIVERSAL_CHARSTRING BankSlotStatusInd_default_coding;
extern UNIVERSAL_CHARSTRING ErrorInd_sender___default_coding;
extern UNIVERSAL_CHARSTRING ErrorInd_severity_default_coding;
extern UNIVERSAL_CHARSTRING ErrorInd_code_default_coding;
extern const TTCN_JSONdescriptor_t ErrorInd_json_;
extern const TTCN_OERdescriptor_t ErrorInd_oer_;
extern const ASN_PERdescriptor_t ErrorInd_per_;
static PerConstraint ErrorInd_per_cons_;
extern const TTCN_Typedescriptor_t ErrorInd_descr_;
extern const ASN_BERdescriptor_t ErrorInd_bankSlot_ber_;
extern const TTCN_OERdescriptor_t ErrorInd_bankSlot_oer_;
extern const ASN_PERdescriptor_t ErrorInd_bankSlot_per_;
static PerConstraint ErrorInd_bankSlot_per_cons_;
extern const TTCN_Typedescriptor_t ErrorInd_bankSlot_descr_;
extern UNIVERSAL_CHARSTRING ErrorInd_bankSlot_default_coding;
extern const ASN_BERdescriptor_t ErrorInd_clientSlot_ber_;
extern const TTCN_OERdescriptor_t ErrorInd_clientSlot_oer_;
extern const ASN_PERdescriptor_t ErrorInd_clientSlot_per_;
static PerConstraint ErrorInd_clientSlot_per_cons_;
extern const TTCN_Typedescriptor_t ErrorInd_clientSlot_descr_;
extern UNIVERSAL_CHARSTRING ErrorInd_clientSlot_default_coding;
extern const ASN_BERdescriptor_t ErrorInd_errorString_ber_;
extern const TTCN_OERdescriptor_t ErrorInd_errorString_oer_;
extern const ASN_PERdescriptor_t ErrorInd_errorString_per_;
extern const TTCN_Typedescriptor_t ErrorInd_errorString_descr_;
extern UNIVERSAL_CHARSTRING ErrorInd_errorString_default_coding;
extern UNIVERSAL_CHARSTRING ErrorInd_default_coding;
extern const TTCN_JSONdescriptor_t ResetStateReq_json_;
extern const TTCN_OERdescriptor_t ResetStateReq_oer_;
extern const ASN_PERdescriptor_t ResetStateReq_per_;
static PerConstraint ResetStateReq_per_cons_;
extern const TTCN_Typedescriptor_t ResetStateReq_descr_;
extern UNIVERSAL_CHARSTRING ResetStateReq_default_coding;
extern UNIVERSAL_CHARSTRING ResetStateRes_result_default_coding;
extern const TTCN_JSONdescriptor_t ResetStateRes_json_;
extern const TTCN_OERdescriptor_t ResetStateRes_oer_;
extern const ASN_PERdescriptor_t ResetStateRes_per_;
static PerConstraint ResetStateRes_per_cons_;
extern const TTCN_Typedescriptor_t ResetStateRes_descr_;
extern UNIVERSAL_CHARSTRING ResetStateRes_default_coding;
extern const TTCN_JSONdescriptor_t RsproPDUchoice_json_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_per_;
static PerConstraint RsproPDUchoice_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_descr_;
extern const ASN_BERdescriptor_t RsproPDUchoice_connectBankReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_connectBankReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_connectBankReq_per_;
static PerConstraint RsproPDUchoice_connectBankReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_connectBankReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_connectBankReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_connectBankRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_connectBankRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_connectBankRes_per_;
static PerConstraint RsproPDUchoice_connectBankRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_connectBankRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_connectBankRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_connectClientReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_connectClientReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_connectClientReq_per_;
static PerConstraint RsproPDUchoice_connectClientReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_connectClientReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_connectClientReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_connectClientRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_connectClientRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_connectClientRes_per_;
static PerConstraint RsproPDUchoice_connectClientRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_connectClientRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_connectClientRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_createMappingReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_createMappingReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_createMappingReq_per_;
static PerConstraint RsproPDUchoice_createMappingReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_createMappingReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_createMappingReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_createMappingRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_createMappingRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_createMappingRes_per_;
static PerConstraint RsproPDUchoice_createMappingRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_createMappingRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_createMappingRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_removeMappingReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_removeMappingReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_removeMappingReq_per_;
static PerConstraint RsproPDUchoice_removeMappingReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_removeMappingReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_removeMappingReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_removeMappingRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_removeMappingRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_removeMappingRes_per_;
static PerConstraint RsproPDUchoice_removeMappingRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_removeMappingRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_removeMappingRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_configClientIdReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_configClientIdReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_configClientIdReq_per_;
static PerConstraint RsproPDUchoice_configClientIdReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_configClientIdReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_configClientIdReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_configClientIdRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_configClientIdRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_configClientIdRes_per_;
static PerConstraint RsproPDUchoice_configClientIdRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_configClientIdRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_configClientIdRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_configClientBankReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_configClientBankReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_configClientBankReq_per_;
static PerConstraint RsproPDUchoice_configClientBankReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_configClientBankReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_configClientBankReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_configClientBankRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_configClientBankRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_configClientBankRes_per_;
static PerConstraint RsproPDUchoice_configClientBankRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_configClientBankRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_configClientBankRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_errorInd_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_errorInd_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_errorInd_per_;
static PerConstraint RsproPDUchoice_errorInd_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_errorInd_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_errorInd_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_resetStateReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_resetStateReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_resetStateReq_per_;
static PerConstraint RsproPDUchoice_resetStateReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_resetStateReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_resetStateReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_resetStateRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_resetStateRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_resetStateRes_per_;
static PerConstraint RsproPDUchoice_resetStateRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_resetStateRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_resetStateRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_setAtrReq_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_setAtrReq_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_setAtrReq_per_;
static PerConstraint RsproPDUchoice_setAtrReq_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_setAtrReq_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_setAtrReq_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_setAtrRes_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_setAtrRes_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_setAtrRes_per_;
static PerConstraint RsproPDUchoice_setAtrRes_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_setAtrRes_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_setAtrRes_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_tpduModemToCard_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_tpduModemToCard_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_tpduModemToCard_per_;
static PerConstraint RsproPDUchoice_tpduModemToCard_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_tpduModemToCard_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_tpduModemToCard_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_tpduCardToModem_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_tpduCardToModem_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_tpduCardToModem_per_;
static PerConstraint RsproPDUchoice_tpduCardToModem_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_tpduCardToModem_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_tpduCardToModem_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_clientSlotStatusInd_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_clientSlotStatusInd_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_clientSlotStatusInd_per_;
static PerConstraint RsproPDUchoice_clientSlotStatusInd_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_clientSlotStatusInd_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_clientSlotStatusInd_default_coding;
extern const ASN_BERdescriptor_t RsproPDUchoice_bankSlotStatusInd_ber_;
extern const TTCN_OERdescriptor_t RsproPDUchoice_bankSlotStatusInd_oer_;
extern const ASN_PERdescriptor_t RsproPDUchoice_bankSlotStatusInd_per_;
static PerConstraint RsproPDUchoice_bankSlotStatusInd_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDUchoice_bankSlotStatusInd_descr_;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_bankSlotStatusInd_default_coding;
extern UNIVERSAL_CHARSTRING RsproPDUchoice_default_coding;
extern const ASN_BERdescriptor_t RsproPDU_version_ber_;
extern const TTCN_OERdescriptor_t RsproPDU_version_oer_;
extern const ASN_PERdescriptor_t RsproPDU_version_per_;
extern const TTCN_Typedescriptor_t RsproPDU_version_descr_;
extern UNIVERSAL_CHARSTRING RsproPDU_version_default_coding;
extern const ASN_BERdescriptor_t RsproPDU_tag_ber_;
extern const TTCN_OERdescriptor_t RsproPDU_tag_oer_;
extern const ASN_PERdescriptor_t RsproPDU_tag_per_;
extern const TTCN_Typedescriptor_t RsproPDU_tag_descr_;
extern UNIVERSAL_CHARSTRING RsproPDU_tag_default_coding;
extern const ASN_BERdescriptor_t RsproPDU_msg_ber_;
extern const TTCN_OERdescriptor_t RsproPDU_msg_oer_;
extern const ASN_PERdescriptor_t RsproPDU_msg_per_;
static PerConstraint RsproPDU_msg_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDU_msg_descr_;
extern UNIVERSAL_CHARSTRING RsproPDU_msg_default_coding;
extern const TTCN_JSONdescriptor_t RsproPDU_json_;
extern const TTCN_OERdescriptor_t RsproPDU_oer_;
extern const ASN_PERdescriptor_t RsproPDU_per_;
static PerConstraint RsproPDU_per_cons_;
extern const TTCN_Typedescriptor_t RsproPDU_descr_;
extern UNIVERSAL_CHARSTRING RsproPDU_default_coding;
extern TTCN_Module module_object;
extern const RuntimeVersionChecker ver_checker;

} /* end of namespace */

#endif
